/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of URPM.xs. Do not edit this file, edit URPM.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "URPM.xs"
/* Copyright (c) 2002, 2003, 2004, 2005 MandrakeSoft SA
 * Copyright (c) 2005, 2006 Mandriva SA
 *
 * All rights reserved.
 * This program is free software; you can redistribute it and/or
 * modify it under the same terms as Perl itself.
 *
 * $Id: URPM.xs 130563 2007-03-01 16:19:00Z nanardon $
 * 
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <sys/utsname.h>
#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>
#include <zlib.h>
#include <libintl.h>

#undef Fflush
#undef Mkdir
#undef Stat
#ifdef RPM_446
#   define _RPMPS_INTERNAL
#endif
#include <rpm/rpmlib.h>
#include <rpm/header.h>
#include <rpm/rpmio.h>
#include <rpm/rpmdb.h>
#include <rpm/rpmts.h>
#include <rpm/rpmps.h>
#include <rpm/rpmpgp.h>
#include <rpm/rpmcli.h>
#include <rpm/rpmbuild.h>

struct s_Package {
  char *info;
  char *requires;
  char *obsoletes;
  char *conflicts;
  char *provides;
  char *rflags;
  char *summary;
  unsigned flag;
  Header h;
};

struct s_Transaction {
  rpmts ts;
  int count;
};

struct s_TransactionData {
  SV* callback_open;
  SV* callback_close;
  SV* callback_trans;
  SV* callback_uninst;
  SV* callback_inst;
  long min_delta;
  SV *data; /* chain with another data user provided */
};

typedef struct s_Transaction* URPM__DB;
typedef struct s_Transaction* URPM__Transaction;
typedef struct s_Package* URPM__Package;

#define FLAG_ID               0x001fffffU
#define FLAG_RATE             0x00e00000U
#define FLAG_BASE             0x01000000U
#define FLAG_SKIP             0x02000000U
#define FLAG_DISABLE_OBSOLETE 0x04000000U
#define FLAG_INSTALLED        0x08000000U
#define FLAG_REQUESTED        0x10000000U
#define FLAG_REQUIRED         0x20000000U
#define FLAG_UPGRADE          0x40000000U
#define FLAG_NO_HEADER_FREE   0x80000000U

#define FLAG_ID_MAX           0x001ffffe
#define FLAG_ID_INVALID       0x001fffff

#define FLAG_RATE_POS         21
#define FLAG_RATE_MAX         5
#define FLAG_RATE_INVALID     0


#define FILENAME_TAG 1000000
#define FILESIZE_TAG 1000001

#define FILTER_MODE_ALL_FILES     0
#define FILTER_MODE_UPGRADE_FILES 1
#define FILTER_MODE_CONF_FILES    2

/* promote epoch sense should be :
     0 for compability with old packages
     1 for rpm 4.2 and better new approach. */
#define PROMOTE_EPOCH_SENSE       1

static int rpmError_callback_data;
void rpmError_callback() {
  if (rpmErrorCode() != RPMERR_UNLINK && rpmErrorCode() != RPMERR_RMDIR) {
    write(rpmError_callback_data, rpmErrorString(), strlen(rpmErrorString()));
  }
}

/* needed for importing keys (from rpmio) */
int rpmioSlurp(const char * fn, const byte ** bp, ssize_t * blenp);
int b64decode (const char * s, void ** datap, size_t *lenp);

static int rpm_codeset_is_utf8 = 0;

static SV*
newSVpv_utf8(const char *s, STRLEN len)
{
  SV *sv = newSVpv(s, len);
  SvUTF8_on(sv);
  return sv;
}

static void
get_fullname_parts(URPM__Package pkg, char **name, char **version, char **release, char **arch, char **eos) {
  char *_version = NULL, *_release = NULL, *_arch = NULL, *_eos = NULL;

  if ((_eos = strchr(pkg->info, '@')) != NULL) {
    *_eos = 0; /* mark end of string to enable searching backwards */
    if ((_arch = strrchr(pkg->info, '.')) != NULL) {
      *_arch = 0;
      if ((release != NULL || version != NULL || name != NULL) && (_release = strrchr(pkg->info, '-')) != NULL) {
	*_release = 0;
	if ((version != NULL || name != NULL) && (_version = strrchr(pkg->info, '-')) != NULL) {
	  if (name != NULL) *name = pkg->info;
	  if (version != NULL) *version = _version + 1;
	}
	if (release != NULL) *release = _release + 1;
	*_release = '-';
      }
      if (arch != NULL) *arch = _arch + 1;
      *_arch = '.';
    }
    if (eos != NULL) *eos = _eos;
    *_eos = '@';
  }
}

static char *
get_name(Header header, int_32 tag) {
  int_32 type, count;
  char *name;

  headerGetEntry(header, tag, &type, (void **) &name, &count);
  return name ? name : "";
}

static int
get_int(Header header, int_32 tag) {
  int_32 type, count;
  int *i;

  headerGetEntry(header, tag, &type, (void **) &i, &count);
  return i ? *i : 0;
}

static int
print_list_entry(char *buff, int sz, char *name, int_32 flags, char *evr) {
  int len = strlen(name);
  char *p = buff;

  if (len >= sz || !strncmp(name, "rpmlib(", 7)) return -1;
  memcpy(p, name, len); p += len;

  if (flags & (RPMSENSE_PREREQ|RPMSENSE_SCRIPT_PREUN|RPMSENSE_SCRIPT_PRE|RPMSENSE_SCRIPT_POSTUN|RPMSENSE_SCRIPT_POST)) {
    if (p - buff + 3 >= sz) return -1;
    memcpy(p, "[*]", 4); p += 3;
  }
  if (evr != NULL) {
    len = strlen(evr);
    if (len > 0) {
      if (p - buff + 6 + len >= sz) return -1;
      *p++ = '[';
      if (flags & RPMSENSE_LESS) *p++ = '<';
      if (flags & RPMSENSE_GREATER) *p++ = '>';
      if (flags & RPMSENSE_EQUAL) *p++ = '=';
      if ((flags & (RPMSENSE_LESS|RPMSENSE_EQUAL|RPMSENSE_GREATER)) == RPMSENSE_EQUAL) *p++ = '=';
      *p++ = ' ';
      memcpy(p, evr, len); p+= len;
      *p++ = ']';
    }
  }
  *p = 0; /* make sure to mark null char, Is it really necessary ? */

  return p - buff;
}

static int
ranges_overlap(int_32 aflags, char *sa, int_32 bflags, char *sb, int b_nopromote) {
  if (!aflags || !bflags)
    return 1; /* really faster to test it there instead of later */
  else {
    int sense = 0;
    char *eosa = strchr(sa, ']');
    char *eosb = strchr(sb, ']');
    char *ea, *va, *ra, *eb, *vb, *rb;

    if (eosa) *eosa = 0;
    if (eosb) *eosb = 0;
    /* parse sa as an [epoch:]version[-release] */
    for (ea = sa; *sa >= '0' && *sa <= '9'; ++sa);
    if (*sa == ':') {
      *sa++ = 0; /* ea could be an empty string (should be interpreted as 0) */
      va = sa;
    } else {
      va = ea; /* no epoch */
      ea = NULL;
    }
    if ((ra = strrchr(sa, '-'))) *ra++ = 0;
    /* parse sb as an [epoch:]version[-release] */
    for (eb = sb; *sb >= '0' && *sb <= '9'; ++sb);
    if (*sb == ':') {
      *sb++ = 0; /* ea could be an empty string (should be interpreted as 0) */
      vb = sb;
    } else {
      vb = eb; /* no epoch */
      eb = NULL;
    }
    if ((rb = strrchr(sb, '-'))) *rb++ = 0;
    /* now compare epoch */
    if (ea && eb)
      sense = rpmvercmp(*ea ? ea : "0", *eb ? eb : "0");
    else if (ea && *ea && atol(ea) > 0)
      sense = b_nopromote ? 1 : 0;
    else if (eb && *eb && atol(eb) > 0)
      sense = -1;
    /* now compare version and release if epoch has not been enough */
    if (sense == 0) {
      sense = rpmvercmp(va, vb);
      if (sense == 0 && ra && *ra && rb && *rb)
	sense = rpmvercmp(ra, rb);
    }
    /* restore all character that have been modified inline */
    if (rb) rb[-1] = '-';
    if (ra) ra[-1] = '-';
    if (eb) vb[-1] = ':';
    if (ea) va[-1] = ':';
    if (eosb) *eosb = ']';
    if (eosa) *eosa = ']';
    /* finish the overlap computation */
    if (sense < 0 && ((aflags & RPMSENSE_GREATER) || (bflags & RPMSENSE_LESS)))
      return 1;
    else if (sense > 0 && ((aflags & RPMSENSE_LESS) || (bflags & RPMSENSE_GREATER)))
      return 1;
    else if (sense == 0 && (((aflags & RPMSENSE_EQUAL) && (bflags & RPMSENSE_EQUAL)) ||
			    ((aflags & RPMSENSE_LESS) && (bflags & RPMSENSE_LESS)) ||
			    ((aflags & RPMSENSE_GREATER) && (bflags & RPMSENSE_GREATER))))
      return 1;
    else
      return 0;
  }
}

typedef int (*callback_list_str)(char *s, int slen, char *name, int_32 flags, char *evr, void *param);

static int
callback_list_str_xpush(char *s, int slen, char *name, int_32 flags, char *evr, void *param) {
  dSP;
  if (s) {
    XPUSHs(sv_2mortal(newSVpv(s, slen)));
  } else {
    char buff[4096];
    int len = print_list_entry(buff, sizeof(buff)-1, name, flags, evr);
    if (len >= 0)
      XPUSHs(sv_2mortal(newSVpv(buff, len)));
  }
  PUTBACK;
  /* returning zero indicates to continue processing */
  return 0;
}

struct cb_overlap_s {
  char *name;
  int_32 flags;
  char *evr;
  int direction; /* indicate to compare the above at left or right to the iteration element */
  int b_nopromote;
};

static int
callback_list_str_overlap(char *s, int slen, char *name, int_32 flags, char *evr, void *param) {
  struct cb_overlap_s *os = (struct cb_overlap_s *)param;
  int result = 0;
  char *eos = NULL;
  char *eon = NULL;
  char eosc = '\0';
  char eonc = '\0';

  /* we need to extract name, flags and evr from a full sense information, store result in local copy */
  if (s) {
    if (slen) { eos = s + slen; eosc = *eos; *eos = 0; }
    name = s;
    while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
    if (*s) {
      eon = s;
      while (*s) {
	if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
	else if (*s == '<') flags |= RPMSENSE_LESS;
	else if (*s == '>') flags |= RPMSENSE_GREATER;
	else if (*s == '=') flags |= RPMSENSE_EQUAL;
	else break;
	++s;
      }
      evr = s;
    } else
      evr = "";
  }

  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* names should be equal, else it will not overlap */
  if (!strcmp(name, os->name)) {
    /* perform overlap according to direction needed, negative for left */
    if (os->direction < 0)
      result = ranges_overlap(os->flags, os->evr, flags, evr, os->b_nopromote);
    else
      result = ranges_overlap(flags, evr, os->flags, os->evr, os->b_nopromote);
  }

  /* fprintf(stderr, "cb_list_str_overlap result=%d, os->direction=%d, os->name=%s, os->evr=%s, name=%s, evr=%s\n",
     result, os->direction, os->name, os->evr, name, evr); */

  /* restore s if needed */
  if (eon) *eon = eonc;
  if (eos) *eos = eosc;

  return result;
}

static int
return_list_str(char *s, Header header, int_32 tag_name, int_32 tag_flags, int_32 tag_version, callback_list_str f, void *param) {
  int count = 0;

  if (s != NULL) {
    char *ps = strchr(s, '@');
    if (tag_flags && tag_version) {
      while(ps != NULL) {
	++count;
	if (f(s, ps-s, NULL, 0, NULL, param)) return -count;
	s = ps + 1; ps = strchr(s, '@');
      }
      ++count;
      if (f(s, 0, NULL, 0, NULL, param)) return -count;
    } else {
      char *eos;
      while(ps != NULL) {
	*ps = 0; eos = strchr(s, '['); if (!eos) eos = strchr(s, ' ');
	++count;
	if (f(s, eos ? eos-s : ps-s, NULL, 0, NULL, param)) { *ps = '@'; return -count; }
	*ps = '@'; /* restore in memory modified char */
	s = ps + 1; ps = strchr(s, '@');
      }
      eos = strchr(s, '['); if (!eos) eos = strchr(s, ' ');
      ++count;
      if (f(s, eos ? eos-s : 0, NULL, 0, NULL, param)) return -count;
    }
  } else if (header) {
    int_32 type, c;
    char **list = NULL;
    int_32 *flags = NULL;
    char **list_evr = NULL;
    int i;

    headerGetEntry(header, tag_name, &type, (void **) &list, &c);
    if (list) {
      if (tag_flags) headerGetEntry(header, tag_flags, &type, (void **) &flags, &c);
      if (tag_version) headerGetEntry(header, tag_version, &type, (void **) &list_evr, &c);
      for(i = 0; i < c; i++) {
	++count;
	if (f(NULL, 0, list[i], flags ? flags[i] : 0, list_evr ? list_evr[i] : NULL, param)) {
	  free(list);
	  free(list_evr);
	  return -count;
	}
      }
      free(list);
      free(list_evr);
    }
  }
  return count;
}

void
return_list_int_32(Header header, int_32 tag_name) {
  dSP;
  if (header) {
    int_32 type, count;
    int_32 *list = NULL;
    int i;

    headerGetEntry(header, tag_name, &type, (void **) &list, &count);
    if (list) {
      for(i = 0; i < count; i++) {
	XPUSHs(sv_2mortal(newSViv(list[i])));
      }
    }
  }
  PUTBACK;
}

void
return_list_uint_16(Header header, int_32 tag_name) {
  dSP;
  if (header) {
    int_32 type, count;
    uint_16 *list = NULL;
    int i;

    headerGetEntry(header, tag_name, &type, (void **) &list, &count);
    if (list) {
      for(i = 0; i < count; i++) {
	XPUSHs(sv_2mortal(newSViv(list[i])));
      }
    }
  }
  PUTBACK;
}

void
return_list_tag_modifier(Header header, int_32 tag_name) {
  dSP;
  int i;
  int_32 *list;
  int_32 count, type;
  headerGetEntry(header, tag_name, &type, (void **) &list, &count);

  for (i = 0; i < count; i++) {
    char buff[15];
    char *s = buff;
    switch (tag_name) {
    case RPMTAG_FILEFLAGS:
      if (list[i] & RPMFILE_CONFIG)    *s++ = 'c';
      if (list[i] & RPMFILE_DOC)       *s++ = 'd';
      if (list[i] & RPMFILE_GHOST)     *s++ = 'g';
      if (list[i] & RPMFILE_LICENSE)   *s++ = 'l';
      if (list[i] & RPMFILE_MISSINGOK) *s++ = 'm';
      if (list[i] & RPMFILE_NOREPLACE) *s++ = 'n';
      if (list[i] & RPMFILE_SPECFILE)  *s++ = 'S';
      if (list[i] & RPMFILE_README)    *s++ = 'R';
      if (list[i] & RPMFILE_EXCLUDE)   *s++ = 'e';
      if (list[i] & RPMFILE_ICON)      *s++ = 'i';
      if (list[i] & RPMFILE_UNPATCHED) *s++ = 'u';
      if (list[i] & RPMFILE_PUBKEY)    *s++ = 'p';
    break;
    default:
      return;  
    }
    *s = '\0';
    XPUSHs(sv_2mortal(newSVpv(buff, strlen(buff))));
  }
  PUTBACK;
}

void
return_list_tag(URPM__Package pkg, int_32 tag_name) {
  dSP;
  if (pkg->h != NULL) {
    void *list = NULL;
    int_32 count, type;
    headerGetEntry(pkg->h, tag_name, &type, (void **) &list, &count);

    if (list) {
      if (tag_name == RPMTAG_ARCH) {
	XPUSHs(sv_2mortal(newSVpv(headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? (char *) list : "src", 0)));
      } else
	switch (type) {
	  case RPM_NULL_TYPE:
	    break;
	  case RPM_CHAR_TYPE:
	  case RPM_INT8_TYPE:
	  case RPM_INT16_TYPE:
	  case RPM_INT32_TYPE:
	    {
	      int i;
	      int *r;
	      r = (int *)list;
	      for (i=0; i < count; i++) {
		XPUSHs(sv_2mortal(newSViv(r[i])));
	      }
	    }
	    break;
	  case RPM_STRING_TYPE:
	    XPUSHs(sv_2mortal(newSVpv((char *) list, 0)));
	    break;
	  case RPM_BIN_TYPE:
	    break;
	  case RPM_STRING_ARRAY_TYPE:
	    {
	      int i;
	      char **s;

	      s = (char **)list;
	      for (i = 0; i < count; i++) {
		XPUSHs(sv_2mortal(newSVpv(s[i], 0)));
	      }
	    }
	    break;
	  case RPM_I18NSTRING_TYPE:
	    break;
	}
    }
  } else {
    char *name;
    char *version;
    char *release;
    char *arch;
    char *eos;
    switch (tag_name) {
      case RPMTAG_NAME:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  if (version - name < 1) croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(name, version-name - 1)));
	}
	break;
      case RPMTAG_VERSION:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  if (release - version < 1) croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(version, release-version - 1)));
	}
	break;
      case RPMTAG_RELEASE:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  if (arch - release < 1) croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(release, arch-release - 1)));
	}
	break;
      case RPMTAG_ARCH:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  XPUSHs(sv_2mortal(newSVpv(arch, eos-arch)));
	}
	break;
      case RPMTAG_SUMMARY:
	XPUSHs(sv_2mortal(newSVpv(pkg->summary, 0)));
	break;
    }
  }
  PUTBACK;
}


void
return_files(Header header, int filter_mode) {
  dSP;
  if (header) {
    char buff[4096];
    char *p, *s;
    STRLEN len;
    int_32 type, count;
    char **list = NULL;
    char **baseNames = NULL;
    char **dirNames = NULL;
    int_32 *dirIndexes = NULL;
    int_32 *flags = NULL;
    uint_16 *fmodes = NULL;
    int i;

    if (filter_mode) {
      headerGetEntry(header, RPMTAG_FILEFLAGS, &type, (void **) &flags, &count);
      headerGetEntry(header, RPMTAG_FILEMODES, &type, (void **) &fmodes, &count);
    }

    headerGetEntry(header, RPMTAG_BASENAMES, &type, (void **) &baseNames, &count);
    headerGetEntry(header, RPMTAG_DIRINDEXES, &type, (void **) &dirIndexes, NULL);
    headerGetEntry(header, RPMTAG_DIRNAMES, &type, (void **) &dirNames, NULL);
    if (!baseNames || !dirNames || !dirIndexes) {
      headerGetEntry(header, RPMTAG_OLDFILENAMES, &type, (void **) &list, &count);
      if (!list) return;
    }

    for(i = 0; i < count; i++) {
      if (list) {
	s = list[i];
	len = strlen(list[i]);
      } else {
	len = strlen(dirNames[dirIndexes[i]]);
	if (len >= sizeof(buff)) continue;
	memcpy(p = buff, dirNames[dirIndexes[i]], len + 1); p += len;
	len = strlen(baseNames[i]);
	if (p - buff + len >= sizeof(buff)) continue;
	memcpy(p, baseNames[i], len + 1); p += len;
	s = buff;
	len = p-buff;
      }

      if (filter_mode) {
	if ((filter_mode & FILTER_MODE_CONF_FILES) && flags && (flags[i] & RPMFILE_CONFIG) == 0) continue;
	if ((filter_mode & FILTER_MODE_UPGRADE_FILES) && fmodes &&
	    (S_ISDIR(fmodes[i]) || S_ISLNK(fmodes[i]) ||
	     !strncmp(s, "/dev", 4) || !strncmp(s, "/etc/rc.d", 9) ||
	     (len >= 3 && !strncmp(s+len-3, ".la", 3)))) continue;
      }

      XPUSHs(sv_2mortal(newSVpv(s, len)));
    }

    free(baseNames);
    free(dirNames);
    free(list);
  }
  PUTBACK;
}

void
return_problems(rpmps ps, int translate_message) {
  dSP;
  if (ps && ps->probs && ps->numProblems > 0) {
    int i;

    for (i = 0; i < ps->numProblems; i++) {
      rpmProblem p = ps->probs + i;

      if (p->ignoreProblem)
	continue;

      if (translate_message) {
	/* translate error using rpm localization */
	const char *buf = rpmProblemString(ps->probs + i);
	SV *sv = newSVpv(buf, 0);
	if (rpm_codeset_is_utf8) SvUTF8_on(sv);
	XPUSHs(sv_2mortal(sv));
	_free(buf);
      } else {
	const char *pkgNEVR = p->pkgNEVR ? p->pkgNEVR : "";
	const char *altNEVR = p->altNEVR ? p->altNEVR : "";
	const char *s = p->str1 ? p->str1 : "";
	SV *sv;

	switch (p->type) {
	case RPMPROB_BADARCH:
	  sv = newSVpvf("badarch@%s", pkgNEVR); break;

	case RPMPROB_BADOS:
	  sv = newSVpvf("bados@%s", pkgNEVR); break;

	case RPMPROB_PKG_INSTALLED:
	  sv = newSVpvf("installed@%s", pkgNEVR); break;

	case RPMPROB_BADRELOCATE:
	  sv = newSVpvf("badrelocate@%s@%s", pkgNEVR, s); break;

	case RPMPROB_NEW_FILE_CONFLICT:
	case RPMPROB_FILE_CONFLICT:
	  sv = newSVpvf("conflicts@%s@%s@%s", pkgNEVR, altNEVR, s); break;

	case RPMPROB_OLDPACKAGE:
	  sv = newSVpvf("installed@%s@%s", pkgNEVR, altNEVR); break;

	case RPMPROB_DISKSPACE:
	  sv = newSVpvf("diskspace@%s@%s@%ld", pkgNEVR, s, p->ulong1); break;

	case RPMPROB_DISKNODES:
	  sv = newSVpvf("disknodes@%s@%s@%ld", pkgNEVR, s, p->ulong1); break;

	case RPMPROB_BADPRETRANS:
	  sv = newSVpvf("badpretrans@%s@%s@%s", pkgNEVR, s, strerror(p->ulong1)); break;

	case RPMPROB_REQUIRES:
	  sv = newSVpvf("requires@%s@%s", pkgNEVR, altNEVR+2); break;

	case RPMPROB_CONFLICT:
	  sv = newSVpvf("conflicts@%s@%s", pkgNEVR, altNEVR+2); break;

	default:
	  sv = newSVpvf("unknown@%s", pkgNEVR); break;
	}
	XPUSHs(sv_2mortal(sv));
      }
    }
  }
  PUTBACK;
}

static char *
pack_list(Header header, int_32 tag_name, int_32 tag_flags, int_32 tag_version) {
  char buff[65536];
  int_32 type, count;
  char **list = NULL;
  int_32 *flags = NULL;
  char **list_evr = NULL;
  int i;
  char *p = buff;

  headerGetEntry(header, tag_name, &type, (void **) &list, &count);
  if (list) {
    if (tag_flags) headerGetEntry(header, tag_flags, &type, (void **) &flags, &count);
    if (tag_version) headerGetEntry(header, tag_version, &type, (void **) &list_evr, &count);
    for(i = 0; i < count; i++) {
      int len = print_list_entry(p, sizeof(buff)-(p-buff)-1, list[i], flags ? flags[i] : 0, list_evr ? list_evr[i] : NULL);
      if (len < 0) continue;
      p += len;
      *p++ = '@';
    }
    if (p > buff) p[-1] = 0;

    free(list);
    free(list_evr);
  }

  return p > buff ? memcpy(malloc(p-buff), buff, p-buff) : NULL;
}

static void
pack_header(URPM__Package pkg) {
  if (pkg->h) {
    if (pkg->info == NULL) {
      char buff[1024];
      char *p = buff;
      char *name = get_name(pkg->h, RPMTAG_NAME);
      char *version = get_name(pkg->h, RPMTAG_VERSION);
      char *release = get_name(pkg->h, RPMTAG_RELEASE);
      char *arch = headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? get_name(pkg->h, RPMTAG_ARCH) : "src";
      char *filename = get_name(pkg->h, FILENAME_TAG);

      p += snprintf(buff, sizeof(buff), "%s-%s-%s.%s@%d@%d@%s@", name, version, release, arch,
		    get_int(pkg->h, RPMTAG_EPOCH), get_int(pkg->h, RPMTAG_SIZE), get_name(pkg->h, RPMTAG_GROUP));
      if (filename) snprintf(p, sizeof(buff) - (p-buff), "%s-%s-%s.%s.rpm", name, version, release, arch);
      if (!filename || !strcmp(p, filename)) {
	p[-1] = 0;
      } else {
	p = p + 1 + snprintf(p, sizeof(buff) - (p-buff), "%s", filename);
      }
      pkg->info = memcpy(malloc(p-buff), buff, p-buff);
    }
    if (pkg->requires == NULL)
      pkg->requires = pack_list(pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION);
    if (pkg->obsoletes == NULL)
      pkg->obsoletes = pack_list(pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION);
    if (pkg->conflicts == NULL)
      pkg->conflicts = pack_list(pkg->h, RPMTAG_CONFLICTNAME, RPMTAG_CONFLICTFLAGS, RPMTAG_CONFLICTVERSION);
    if (pkg->provides == NULL)
      pkg->provides = pack_list(pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION);
    if (pkg->summary == NULL) {
      char *summary = get_name(pkg->h, RPMTAG_SUMMARY);
      int len = 1 + strlen(summary);

      pkg->summary = memcpy(malloc(len), summary, len);
    }

    if (!(pkg->flag & FLAG_NO_HEADER_FREE)) headerFree(pkg->h);
    pkg->h = 0;
  }
}

static void
update_provide_entry(char *name, STRLEN len, int force, IV use_sense, URPM__Package pkg, HV *provides) {
  SV** isv;

  if (!len) len = strlen(name);
  if ((isv = hv_fetch(provides, name, len, force))) {
    /* check if an entry has been found or created, it should so be updated */
    if (!SvROK(*isv) || SvTYPE(SvRV(*isv)) != SVt_PVHV) {
      SV* choice_set = (SV*)newHV();
      if (choice_set) {
	SvREFCNT_dec(*isv); /* drop the old as we are changing it */
	if (!(*isv = newRV_noinc(choice_set))) {
	  SvREFCNT_dec(choice_set);
	  *isv = &PL_sv_undef;
	}
      }
    }
    if (isv && *isv != &PL_sv_undef) {
      char id[8];
      STRLEN id_len = snprintf(id, sizeof(id), "%d", pkg->flag & FLAG_ID);
      SV **sense = hv_fetch((HV*)SvRV(*isv), id, id_len, 1);
      if (sense && use_sense) sv_setiv(*sense, use_sense);
    }
  }
}

static void
update_provides(URPM__Package pkg, HV *provides) {
  if (pkg->h) {
    int len;
    int_32 type, count;
    char **list = NULL;
    int_32 *flags = NULL;
    int i;

    /* examine requires for files which need to be marked in provides */
    headerGetEntry(pkg->h, RPMTAG_REQUIRENAME, &type, (void **) &list, &count);
    if (list) {
      for (i = 0; i < count; ++i) {
	len = strlen(list[i]);
	if (list[i][0] == '/') hv_fetch(provides, list[i], len, 1);
      }
    }

    /* update all provides */
    headerGetEntry(pkg->h, RPMTAG_PROVIDENAME, &type, (void **) &list, &count);
    if (list) {
      headerGetEntry(pkg->h, RPMTAG_PROVIDEFLAGS, &type, (void **) &flags, &count);
      for (i = 0; i < count; ++i) {
	len = strlen(list[i]);
	if (!strncmp(list[i], "rpmlib(", 7)) continue;
	update_provide_entry(list[i], len, 1, flags && flags[i] & (RPMSENSE_PREREQ|RPMSENSE_SCRIPT_PREUN|RPMSENSE_SCRIPT_PRE|RPMSENSE_SCRIPT_POSTUN|RPMSENSE_SCRIPT_POST|RPMSENSE_LESS|RPMSENSE_EQUAL|RPMSENSE_GREATER),
			     pkg, provides);
      }
    }
  } else {
    char *ps, *s, *es;

    if ((s = pkg->requires) != NULL && *s != 0) {
      ps = strchr(s, '@');
      while(ps != NULL) {
	if (s[0] == '/') {
	  *ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	  hv_fetch(provides, s, es != NULL ? es-s : ps-s, 1);
	}
	s = ps + 1; ps = strchr(s, '@');
      }
      if (s[0] == '/') {
	es = strchr(s, '['); if (!es) es = strchr(s, ' ');
	hv_fetch(provides, s, es != NULL ? es-s : strlen(s), 1);
      }
    }

    if ((s = pkg->provides) != NULL && *s != 0) {
      char *es;

      ps = strchr(s, '@');
      while(ps != NULL) {
	*ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	update_provide_entry(s, es != NULL ? es-s : ps-s, 1, es != NULL, pkg, provides);
	s = ps + 1; ps = strchr(s, '@');
      }
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
      update_provide_entry(s, es != NULL ? es-s : 0, 1, es != NULL, pkg, provides);
    }
  }
}

static void
update_provides_files(URPM__Package pkg, HV *provides) {
  if (pkg->h) {
    STRLEN len;
    int_32 type, count;
    char **list = NULL;
    char **baseNames = NULL;
    char **dirNames = NULL;
    int_32 *dirIndexes = NULL;
    int i;

    headerGetEntry(pkg->h, RPMTAG_BASENAMES, &type, (void **) &baseNames, &count);
    headerGetEntry(pkg->h, RPMTAG_DIRINDEXES, &type, (void **) &dirIndexes, NULL);
    headerGetEntry(pkg->h, RPMTAG_DIRNAMES, &type, (void **) &dirNames, NULL);
    if (baseNames && dirNames && dirIndexes) {
      char buff[4096];
      char *p;

      for(i = 0; i < count; i++) {
	len = strlen(dirNames[dirIndexes[i]]);
	if (len >= sizeof(buff)) continue;
	memcpy(p = buff, dirNames[dirIndexes[i]], len + 1); p += len;
	len = strlen(baseNames[i]);
	if (p - buff + len >= sizeof(buff)) continue;
	memcpy(p, baseNames[i], len + 1); p += len;

	update_provide_entry(buff, p-buff, 0, 0, pkg, provides);
      }

      free(baseNames);
      free(dirNames);
    } else {
      headerGetEntry(pkg->h, RPMTAG_OLDFILENAMES, &type, (void **) &list, &count);
      if (list) {
	for (i = 0; i < count; i++) {
	  len = strlen(list[i]);

	  update_provide_entry(list[i], len, 0, 0, pkg, provides);
	}

	free(list);
      }
    }
  }
}

int
open_archive(char *filename, pid_t *pid, int *empty_archive) {
  int fd;
  struct {
    char header[4];
    char toc_d_count[4];
    char toc_l_count[4];
    char toc_f_count[4];
    char toc_str_size[4];
    char uncompress[40];
    char trailer[4];
  } buf;

  fd = open(filename, O_RDONLY);
  if (fd >= 0) {
    int pos = lseek(fd, -(int)sizeof(buf), SEEK_END);
    if (read(fd, &buf, sizeof(buf)) != sizeof(buf) || strncmp(buf.header, "cz[0", 4) || strncmp(buf.trailer, "0]cz", 4)) {
      /* this is not an archive, open it without magic, but first rewind at begin of file */
      lseek(fd, 0, SEEK_SET);
    } else if (pos == 0) {
      *empty_archive = 1;
      fd = -1;
    } else {
      /* this is an archive, create a pipe and fork for reading with uncompress defined inside */
      int fdno[2];

      if (!pipe(fdno)) {
	if ((*pid = fork()) != 0) {
	  fd_set readfds;
	  struct timeval timeout;

	  FD_ZERO(&readfds);
	  FD_SET(fdno[0], &readfds);
	  timeout.tv_sec = 1;
	  timeout.tv_usec = 0;
	  select(fdno[0]+1, &readfds, NULL, NULL, &timeout);

	  close(fd);
	  fd = fdno[0];
	  close(fdno[1]);
	} else {
	  char *unpacker[22]; /* enough for 40 bytes in uncompress to never overbuf */
	  char *p = buf.uncompress;
	  int ip = 0;
	  char *ld_loader = getenv("LD_LOADER");

	  if (ld_loader && *ld_loader) {
	    unpacker[ip++] = ld_loader;
	  }

	  buf.trailer[0] = 0; /* make sure end-of-string is right */
	  while (*p) {
	    if (*p == ' ' || *p == '\t') *p++ = 0;
	    else {
	      unpacker[ip++] = p;
	      while (*p && *p != ' ' && *p != '\t') ++p;
	    }
	  }
	  unpacker[ip] = NULL; /* needed for execlp */

	  lseek(fd, 0, SEEK_SET);
	  dup2(fd, STDIN_FILENO); close(fd);
	  dup2(fdno[1], STDOUT_FILENO); close(fdno[1]);
	  fd = open("/dev/null", O_WRONLY);
	  dup2(fd, STDERR_FILENO); close(fd);
	  execvp(unpacker[0], unpacker);
	  exit(1);
	}
      } else {
	close(fd);
	fd = -1;
      }
    }
  }
  return fd;
}

static int
call_package_callback(SV *urpm, SV *sv_pkg, SV *callback) {
  if (sv_pkg != NULL && callback != NULL) {
    int count;

    /* now, a callback will be called for sure */
    dSP;
    PUSHMARK(SP);
    XPUSHs(urpm);
    XPUSHs(sv_pkg);
    PUTBACK;
    count = call_sv(callback, G_SCALAR);
    SPAGAIN;
    if (count == 1 && !POPi) {
      /* package should not be added in depslist, so we free it */
      SvREFCNT_dec(sv_pkg);
      sv_pkg = NULL;
    }
    PUTBACK;
  }

  return sv_pkg != NULL;
}

static int
parse_line(AV *depslist, HV *provides, URPM__Package pkg, char *buff, SV *urpm, SV *callback) {
  SV *sv_pkg;
  URPM__Package _pkg;
  char *tag, *data;
  int data_len;

  if (buff[0] == 0) {
    return 1;
  } else if ((tag = buff)[0] == '@' && (data = strchr(tag+1, '@')) != NULL) {
    *tag++ = *data++ = 0;
    data_len = 1+strlen(data);
    if (!strcmp(tag, "info")) {
      pkg->info = memcpy(malloc(data_len), data, data_len);
      pkg->flag &= ~FLAG_ID;
      pkg->flag |= 1 + av_len(depslist);
      sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package",
			    _pkg = memcpy(malloc(sizeof(struct s_Package)), pkg, sizeof(struct s_Package)));
      if (call_package_callback(urpm, sv_pkg, callback)) {
	if (provides) update_provides(_pkg, provides);
	av_push(depslist, sv_pkg);
      }
      memset(pkg, 0, sizeof(struct s_Package));
    } else if (!strcmp(tag, "requires")) {
      free(pkg->requires); pkg->requires = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "obsoletes")) {
      free(pkg->obsoletes); pkg->obsoletes = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "conflicts")) {
      free(pkg->conflicts); pkg->conflicts = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "provides")) {
      free(pkg->provides); pkg->provides = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "summary")) {
      free(pkg->summary); pkg->summary = memcpy(malloc(data_len), data, data_len);
    }
    return 1;
  } else {
    fprintf(stderr, "bad line <%s>\n", buff);
    return 0;
  }
}

static int
update_header(char *filename, URPM__Package pkg, int keep_all_tags, int vsflags) {
  int d = open(filename, O_RDONLY);

  if (d >= 0) {
    unsigned char sig[4];

    if (read(d, &sig, sizeof(sig)) == sizeof(sig)) {
      lseek(d, 0, SEEK_SET);
      if (sig[0] == 0xed && sig[1] == 0xab && sig[2] == 0xee && sig[3] == 0xdb) {
	FD_t fd = fdDup(d);
	Header header;
	rpmts ts;

	close(d);
	ts = rpmtsCreate();
	rpmtsSetVSFlags(ts, _RPMVSF_NOSIGNATURES | vsflags);
	if (fd != NULL && rpmReadPackageFile(ts, fd, filename, &header) == 0 && header) {
	  struct stat sb;
	  char *basename;
	  int_32 size;

	  basename = strrchr(filename, '/');
	  fstat(fdFileno(fd), &sb);
	  fdClose(fd);
	  size = sb.st_size;
	  headerAddEntry(header, FILENAME_TAG, RPM_STRING_TYPE, basename != NULL ? basename + 1 : filename, 1);
	  headerAddEntry(header, FILESIZE_TAG, RPM_INT32_TYPE, &size, 1);

	  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) headerFree(pkg->h);
	  pkg->h = header;
	  pkg->flag &= ~FLAG_NO_HEADER_FREE;

	  if (!keep_all_tags) {
	    headerRemoveEntry(pkg->h, RPMTAG_POSTIN);
	    headerRemoveEntry(pkg->h, RPMTAG_POSTUN);
	    headerRemoveEntry(pkg->h, RPMTAG_PREIN);
	    headerRemoveEntry(pkg->h, RPMTAG_PREUN);
	    headerRemoveEntry(pkg->h, RPMTAG_FILEUSERNAME);
	    headerRemoveEntry(pkg->h, RPMTAG_FILEGROUPNAME);
	    headerRemoveEntry(pkg->h, RPMTAG_FILEVERIFYFLAGS);
	    headerRemoveEntry(pkg->h, RPMTAG_FILERDEVS);
	    headerRemoveEntry(pkg->h, RPMTAG_FILEMTIMES);
	    headerRemoveEntry(pkg->h, RPMTAG_FILEDEVICES);
	    headerRemoveEntry(pkg->h, RPMTAG_FILEINODES);
	    headerRemoveEntry(pkg->h, RPMTAG_TRIGGERSCRIPTS);
	    headerRemoveEntry(pkg->h, RPMTAG_TRIGGERVERSION);
	    headerRemoveEntry(pkg->h, RPMTAG_TRIGGERFLAGS);
	    headerRemoveEntry(pkg->h, RPMTAG_TRIGGERNAME);
	    headerRemoveEntry(pkg->h, RPMTAG_CHANGELOGTIME);
	    headerRemoveEntry(pkg->h, RPMTAG_CHANGELOGNAME);
	    headerRemoveEntry(pkg->h, RPMTAG_CHANGELOGTEXT);
	    headerRemoveEntry(pkg->h, RPMTAG_ICON);
	    headerRemoveEntry(pkg->h, RPMTAG_GIF);
	    headerRemoveEntry(pkg->h, RPMTAG_VENDOR);
	    headerRemoveEntry(pkg->h, RPMTAG_EXCLUDE);
	    headerRemoveEntry(pkg->h, RPMTAG_EXCLUSIVE);
	    headerRemoveEntry(pkg->h, RPMTAG_DISTRIBUTION);
	    headerRemoveEntry(pkg->h, RPMTAG_VERIFYSCRIPT);
	  }
	  return 1;
	}
	rpmtsFree(ts);
      } else if (sig[0] == 0x8e && sig[1] == 0xad && sig[2] == 0xe8 && sig[3] == 0x01) {
	FD_t fd = fdDup(d);

	close(d);
	if (fd != NULL) {
	  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) headerFree(pkg->h);
	  pkg->h = headerRead(fd, HEADER_MAGIC_YES);
	  pkg->flag &= ~FLAG_NO_HEADER_FREE;
	  fdClose(fd);
	  return 1;
	}
      }
    }
  }
  return 0;
}

static int
read_config_files(int force) {
  static int already = 0;
  int rc = 0;

  if (!already || force) {
    rc = rpmReadConfigFiles(NULL, NULL);
    already = (rc == 0); /* set config as load only if it succeed */
  }
  return rc;
}

static void
ts_nosignature(rpmts ts) {
  rpmtsSetVSFlags(ts, _RPMVSF_NODIGESTS | _RPMVSF_NOSIGNATURES);
}


#ifdef RPM_CALLBACK_LONGLONG
/* That's for rpm >= 4.4.5 */
# define RPM_CALLBACK_AMOUNT_TYPE unsigned long long
#else
# define RPM_CALLBACK_AMOUNT_TYPE unsigned long
#endif

static void *rpmRunTransactions_callback(const void *h,
					 const rpmCallbackType what,
					 const RPM_CALLBACK_AMOUNT_TYPE amount,
					 const RPM_CALLBACK_AMOUNT_TYPE total,
					 const void * pkgKey,
					 void * data) {
  static struct timeval tprev;
  static struct timeval tcurr;
  static FD_t fd = NULL;
  long delta;
  int i;
  struct s_TransactionData *td = data;
  SV *callback = NULL;
  char *callback_type = NULL;
  char *callback_subtype = NULL;

  if (!td)
    return NULL;

  switch (what) {
    case RPMCALLBACK_INST_OPEN_FILE:
      callback = td->callback_open;
      callback_type = "open";
      break;
    case RPMCALLBACK_INST_CLOSE_FILE:
      callback = td->callback_close;
      callback_type = "close";
      break;
    case RPMCALLBACK_TRANS_START:
    case RPMCALLBACK_TRANS_PROGRESS:
    case RPMCALLBACK_TRANS_STOP:
      callback = td->callback_trans;
      callback_type = "trans";
      break;
    case RPMCALLBACK_UNINST_START:
    case RPMCALLBACK_UNINST_PROGRESS:
    case RPMCALLBACK_UNINST_STOP:
      callback = td->callback_uninst;
      callback_type = "uninst";
      break;
    case RPMCALLBACK_INST_START:
    case RPMCALLBACK_INST_PROGRESS:
      callback = td->callback_inst;
      callback_type = "inst";
      break;
    default:
      break;
  }

  if (callback != NULL) {
    switch (what) {
      case RPMCALLBACK_TRANS_START:
      case RPMCALLBACK_UNINST_START:
      case RPMCALLBACK_INST_START:
	callback_subtype = "start";
	gettimeofday(&tprev, NULL);
	break;
      case RPMCALLBACK_TRANS_PROGRESS:
      case RPMCALLBACK_UNINST_PROGRESS:
      case RPMCALLBACK_INST_PROGRESS:
	callback_subtype = "progress";
	gettimeofday(&tcurr, NULL);
	delta = 1000000 * (tcurr.tv_sec - tprev.tv_sec) + (tcurr.tv_usec - tprev.tv_usec);
	if (delta < td->min_delta && amount < total - 1)
	  callback = NULL; /* avoid calling too often a given callback */
	else
	  tprev = tcurr;
	break;
      case RPMCALLBACK_TRANS_STOP:
      case RPMCALLBACK_UNINST_STOP:
	callback_subtype = "stop";
	break;
      default:
	break;
    }

    if (callback != NULL) {
      /* now, a callback will be called for sure */
      dSP;
      ENTER;
      SAVETMPS;
      PUSHMARK(SP);
      XPUSHs(td->data);
      XPUSHs(sv_2mortal(newSVpv(callback_type, 0)));
      XPUSHs(pkgKey != NULL ? sv_2mortal(newSViv((int)pkgKey - 1)) : &PL_sv_undef);
      if (callback_subtype != NULL) {
	XPUSHs(sv_2mortal(newSVpv(callback_subtype, 0)));
	XPUSHs(sv_2mortal(newSViv(amount)));
	XPUSHs(sv_2mortal(newSViv(total)));
      }
      PUTBACK;
      i = call_sv(callback, callback == td->callback_open ? G_SCALAR : G_DISCARD);
      SPAGAIN;
      if (callback == td->callback_open) {
	if (i != 1) croak("callback_open should return a file handle");
	i = POPi;
	fd = fdDup(i);
	if (fd) {
	  fd = fdLink(fd, "persist perl-URPM");
	  Fcntl(fd, F_SETFD, (void *)1); /* necessary to avoid forked/execed process to lock removable */
	}
	PUTBACK;
      } else if (callback == td->callback_close) {
	fd = fdFree(fd, "persist perl-URPM");
	if (fd) {
	  fdClose(fd);
	  fd = NULL;
	}
      }
      FREETMPS;
      LEAVE;
    }
  }
  return callback == td->callback_open ? fd : NULL;
}


#line 1268 "URPM.c"

XS(XS_URPM__Package_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::DESTROY(pkg)");
    {
	URPM__Package	pkg;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not a reference");
#line 1264 "URPM.xs"
  free(pkg->info);
  free(pkg->requires);
  free(pkg->obsoletes);
  free(pkg->conflicts);
  free(pkg->provides);
  free(pkg->rflags);
  free(pkg->summary);
  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) headerFree(pkg->h);
  free(pkg);
#line 1295 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_name)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::name(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1278 "URPM.xs"
  if (pkg->info) {
    char *name;
    char *version;

    get_fullname_parts(pkg, &name, &version, NULL, NULL, NULL);
    if (version - name < 1) croak("invalid fullname");
    XPUSHs(sv_2mortal(newSVpv(name, version-name-1)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_NAME), 0)));
  }
#line 1328 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_version)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::version(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1293 "URPM.xs"
  if (pkg->info) {
    char *version;
    char *release;

    get_fullname_parts(pkg, NULL, &version, &release, NULL, NULL);
    if (release - version < 1) croak("invalid fullname");
    XPUSHs(sv_2mortal(newSVpv(version, release-version-1)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_VERSION), 0)));
  }
#line 1362 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_release); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_release)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::release(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1308 "URPM.xs"
  if (pkg->info) {
    char *release;
    char *arch;

    get_fullname_parts(pkg, NULL, NULL, &release, &arch, NULL);
    if (arch - release < 1) croak("invalid fullname");
    XPUSHs(sv_2mortal(newSVpv(release, arch-release-1)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_RELEASE), 0)));
  }
#line 1396 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_arch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_arch)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::arch(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1323 "URPM.xs"
  if (pkg->info) {
    char *arch;
    char *eos;

    get_fullname_parts(pkg, NULL, NULL, NULL, &arch, &eos);
    XPUSHs(sv_2mortal(newSVpv(arch, eos-arch)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? get_name(pkg->h, RPMTAG_ARCH) : "src", 0)));
  }
#line 1429 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_is_arch_compat); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_is_arch_compat)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::is_arch_compat(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1337 "URPM.xs"
  read_config_files(0);
  if (pkg->info) {
    char *arch;
    char *eos;

    get_fullname_parts(pkg, NULL, NULL, NULL, &arch, &eos);
    *eos = 0;
    RETVAL = rpmMachineScore(RPM_MACHTABLE_INSTARCH, arch);
    *eos = '@';
  } else if (pkg->h && headerIsEntry(pkg->h, RPMTAG_SOURCERPM)) {
    RETVAL = rpmMachineScore(RPM_MACHTABLE_INSTARCH, get_name(pkg->h, RPMTAG_ARCH));
  } else {
    RETVAL = 0;
  }
#line 1468 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_summary); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_summary)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::summary(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1358 "URPM.xs"
  if (pkg->summary) {
    XPUSHs(sv_2mortal(newSVpv_utf8(pkg->summary, 0)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_SUMMARY), 0)));
  }
#line 1497 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_description)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::description(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1368 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_DESCRIPTION), 0)));
  }
#line 1524 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_sourcerpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_sourcerpm)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::sourcerpm(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1376 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_SOURCERPM), 0)));
  }
#line 1551 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_packager); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_packager)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::packager(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1384 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_PACKAGER), 0)));
  }
#line 1578 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_buildhost); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildhost)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::buildhost(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1392 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_BUILDHOST), 0)));
  }
#line 1605 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_buildtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildtime)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::buildtime(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1400 "URPM.xs"
  if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_BUILDTIME);
  } else {
    RETVAL = 0;
  }
#line 1635 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_installtid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_installtid)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::installtid(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1412 "URPM.xs"
  if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_INSTALLTID);
  } else {
    RETVAL = 0;
  }
#line 1665 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_url); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_url)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::url(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1424 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_URL), 0)));
  }
#line 1692 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_license); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_license)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::license(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1432 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_LICENSE), 0)));
  }
#line 1719 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_distribution); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_distribution)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::distribution(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1440 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_DISTRIBUTION), 0)));
  }
#line 1746 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_vendor); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_vendor)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::vendor(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1448 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_VENDOR), 0)));
  }
#line 1773 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_os); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_os)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::os(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1456 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_OS), 0)));
  }
#line 1800 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_payload_format); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_payload_format)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::payload_format(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1464 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_PAYLOADFORMAT), 0)));
  }
#line 1827 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_fullname); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_fullname)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::fullname(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;
#line 1472 "URPM.xs"
  I32 gimme = GIMME_V;
#line 1845 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1474 "URPM.xs"
  if (pkg->info) {
    if (gimme == G_SCALAR) {
      char *eos;
      if ((eos = strchr(pkg->info, '@')) != NULL) {
	XPUSHs(sv_2mortal(newSVpv(pkg->info, eos-pkg->info)));
      }
    } else if (gimme == G_ARRAY) {
      char *name, *version, *release, *arch, *eos;
      get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
      if (version - name < 1 || release - version < 1 || arch - release < 1)
	  croak("invalid fullname");
      EXTEND(SP, 4);
      PUSHs(sv_2mortal(newSVpv(name, version-name-1)));
      PUSHs(sv_2mortal(newSVpv(version, release-version-1)));
      PUSHs(sv_2mortal(newSVpv(release, arch-release-1)));
      PUSHs(sv_2mortal(newSVpv(arch, eos-arch)));
    }
  } else if (pkg->h) {
    char *name = get_name(pkg->h, RPMTAG_NAME);
    char *version = get_name(pkg->h, RPMTAG_VERSION);
    char *release = get_name(pkg->h, RPMTAG_RELEASE);
    char *arch = headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? get_name(pkg->h, RPMTAG_ARCH) : "src";

    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSVpvf("%s-%s-%s.%s", name, version, release, arch)));
    } else if (gimme == G_ARRAY) {
      EXTEND(SP, 4);
      PUSHs(sv_2mortal(newSVpv(name, 0)));
      PUSHs(sv_2mortal(newSVpv(version, 0)));
      PUSHs(sv_2mortal(newSVpv(release, 0)));
      PUSHs(sv_2mortal(newSVpv(arch, 0)));
    }
  }
#line 1887 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_epoch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_epoch)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::epoch(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1512 "URPM.xs"
  if (pkg->info) {
    char *s, *eos;

    if ((s = strchr(pkg->info, '@')) != NULL) {
      if ((eos = strchr(s+1, '@')) != NULL) *eos = 0; /* mark end of string to enable searching backwards */
      RETVAL = atoi(s+1);
      if (eos != NULL) *eos = '@';
    } else {
      RETVAL = 0;
    }
  } else if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_EPOCH);
  } else RETVAL = 0;
#line 1925 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_compare_pkg); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_compare_pkg)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::compare_pkg(lpkg, rpkg)");
    {
	URPM__Package	lpkg;
	URPM__Package	rpkg;
#line 1533 "URPM.xs"
  int compare = 0;
  int lepoch;
  char *lversion;
  char *lrelease;
  char *larch;
  char *leos;
  int repoch;
  char *rversion;
  char *rrelease;
  char *rarch;
  char *reos;
#line 1953 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    lpkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "lpkg is not of type URPM::Package");

	if (sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rpkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "rpkg is not of type URPM::Package");
#line 1545 "URPM.xs"
  if (lpkg == rpkg) RETVAL = 0;
  else {
    if (lpkg->info) {
      char *s;

      if ((s = strchr(lpkg->info, '@')) != NULL) {
	if ((leos = strchr(s+1, '@')) != NULL) *leos = 0; /* mark end of string to enable searching backwards */
	lepoch = atoi(s+1);
	if (leos != NULL) *leos = '@';
      } else {
	lepoch = 0;
      }
      get_fullname_parts(lpkg, NULL, &lversion, &lrelease, &larch, &leos);
      /* temporarily mark end of each substring */
      lrelease[-1] = 0;
      larch[-1] = 0;
    } else if (lpkg->h) {
      lepoch = get_int(lpkg->h, RPMTAG_EPOCH);
      lversion = get_name(lpkg->h, RPMTAG_VERSION);
      lrelease = get_name(lpkg->h, RPMTAG_RELEASE);
      larch = headerIsEntry(lpkg->h, RPMTAG_SOURCERPM) ? get_name(lpkg->h, RPMTAG_ARCH) : "src";
    } else croak("undefined package");
    if (rpkg->info) {
      char *s;

      if ((s = strchr(rpkg->info, '@')) != NULL) {
	if ((reos = strchr(s+1, '@')) != NULL) *reos = 0; /* mark end of string to enable searching backwards */
	repoch = atoi(s+1);
	if (reos != NULL) *reos = '@';
      } else {
	repoch = 0;
      }
      get_fullname_parts(rpkg, NULL, &rversion, &rrelease, &rarch, &reos);
      /* temporarily mark end of each substring */
      rrelease[-1] = 0;
      rarch[-1] = 0;
    } else if (rpkg->h) {
      repoch = get_int(rpkg->h, RPMTAG_EPOCH);
      rversion = get_name(rpkg->h, RPMTAG_VERSION);
      rrelease = get_name(rpkg->h, RPMTAG_RELEASE);
      rarch = headerIsEntry(rpkg->h, RPMTAG_SOURCERPM) ? get_name(rpkg->h, RPMTAG_ARCH) : "src";
    } else {
      /* restore info string modified */
      if (lpkg->info) {
	lrelease[-1] = '-';
	larch[-1] = '.';
      }
      croak("undefined package");
    }
    compare = lepoch - repoch;
    if (!compare) {
      compare = rpmvercmp(lversion, rversion);
      if (!compare) {
	compare = rpmvercmp(lrelease, rrelease);
	if (!compare) {
	  int lscore, rscore;
	  char *eolarch = strchr(larch, '@');
	  char *eorarch = strchr(rarch, '@');

	  read_config_files(0);
	  if (eolarch) *eolarch = 0; lscore = rpmMachineScore(RPM_MACHTABLE_INSTARCH, larch);
	  if (eorarch) *eorarch = 0; rscore = rpmMachineScore(RPM_MACHTABLE_INSTARCH, rarch);
	  if (lscore == 0) {
	    if (rscore == 0)
#if 0
              /* Nanar: TODO check this 
               * hu ?? what is the goal of strcmp, some of arch are equivalent */
              compare = 0
#endif
	      compare = strcmp(larch, rarch);
	    else
	      compare = -1;
	  } else {
	    if (rscore == 0)
	      compare = 1;
	    else
	      compare = rscore - lscore; /* score are lower for better */
	  }
	  if (eolarch) *eolarch = '@';
	  if (eorarch) *eorarch = '@';
	}
      }
    }
    /* restore info string modified */
    if (lpkg->info) {
      lrelease[-1] = '-';
      larch[-1] = '.';
    }
    if (rpkg->info) {
      rrelease[-1] = '-';
      rarch[-1] = '.';
    }
    RETVAL = compare;
  }
#line 2065 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_compare); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_compare)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::compare(pkg, evr)");
    {
	URPM__Package	pkg;
	char *	evr = (char *)SvPV_nolen(ST(1));
#line 1647 "URPM.xs"
  int compare = 0;
  int _epoch;
  char *_version;
  char *_release;
  char *_eos;
#line 2087 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1653 "URPM.xs"
  if (pkg->info) {
    char *s;

    if ((s = strchr(pkg->info, '@')) != NULL) {
      if ((_eos = strchr(s+1, '@')) != NULL) *_eos = 0; /* mark end of string to enable searching backwards */
      _epoch = atoi(s+1);
      if (_eos != NULL) *_eos = '@';
    } else {
      _epoch = 0;
    }
    get_fullname_parts(pkg, NULL, &_version, &_release, &_eos, NULL);
    /* temporarily mark end of each substring */
    _release[-1] = 0;
    _eos[-1] = 0;
  } else if (pkg->h) {
    _epoch = get_int(pkg->h, RPMTAG_EPOCH);
  } else croak("undefined package");
  if (!compare) {
    char *epoch, *version, *release;

    /* extract epoch and version from evr */
    version = evr;
    while (*version && isdigit(*version)) version++;
    if (*version == ':') {
      epoch = evr;
      *version++ = 0;
      if (!*epoch) epoch = "0";
      compare = _epoch - (*epoch ? atoi(epoch) : 0);
      version[-1] = ':'; /* restore in memory modification */
    } else {
      /* there is no epoch defined, so no check on epoch and assume equality */
      version = evr;
    }
    if (!compare) {
      if (!pkg->info)
	_version = get_name(pkg->h, RPMTAG_VERSION);
      /* continue extracting release if any */
      if ((release = strrchr(version, '-')) != NULL) {
	*release++ = 0;
	compare = rpmvercmp(_version, version);
	if (!compare) {
	  /* need to compare with release here */
	  if (!pkg->info)
	    _release = get_name(pkg->h, RPMTAG_RELEASE);
	  compare = rpmvercmp(_release, release);
	}
	release[-1] = '-'; /* restore in memory modification */
      } else {
	compare = rpmvercmp(_version, version);
      }
    }
  }
  /* restore info string modified */
  if (pkg->info) {
    _release[-1] = '-';
    _eos[-1] = '.';
  }
  RETVAL = compare;
#line 2156 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_size)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::size(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1718 "URPM.xs"
  if (pkg->info) {
    char *s, *eos;

    if ((s = strchr(pkg->info, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
      if ((eos = strchr(s+1, '@')) != NULL) *eos = 0; /* mark end of string to enable searching backwards */
      RETVAL = atoi(s+1);
      if (eos != NULL) *eos = '@';
    } else {
      RETVAL = 0;
    }
  } else if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_SIZE);
  } else RETVAL = 0;
#line 2194 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_group); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_group)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::group(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1738 "URPM.xs"
  if (pkg->info) {
    char *s;

    if ((s = strchr(pkg->info, '@')) != NULL && (s = strchr(s+1, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
      char *eos = strchr(s+1, '@');
      XPUSHs(sv_2mortal(newSVpv_utf8(s+1, eos != NULL ? eos-s-1 : 0)));
    }
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_GROUP), 0)));
  }
#line 2228 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_filename); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_filename)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::filename(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1753 "URPM.xs"
  if (pkg->info) {
    char *s, *eon, *eos;

    if ((eon = strchr(pkg->info, '@')) != NULL) {
      if ((s = strchr(eon+1, '@')) != NULL && (s = strchr(s+1, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
	eos = strchr(s+1, '@');
	XPUSHs(sv_2mortal(newSVpv(s+1, eos != NULL ? eos-s-1 : 0)));
      } else {
	char savbuf[4];
	memcpy(savbuf, eon, 4); /* there should be at least epoch and size described so (@0@0 minimum) */
	memcpy(eon, ".rpm", 4);
	XPUSHs(sv_2mortal(newSVpv(pkg->info, eon-pkg->info+4)));
	memcpy(eon, savbuf, 4);
      }
    }
  } else if (pkg->h) {
    char *filename = get_name(pkg->h, FILENAME_TAG);

    if (filename != NULL)
      XPUSHs(sv_2mortal(newSVpv(filename, 0)));
  }
#line 2273 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_header_filename); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_header_filename)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::header_filename(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1779 "URPM.xs"
  if (pkg->info) {
    char *s, *eon, *eos;

    if ((eon = strchr(pkg->info, '@')) != NULL) {
      if ((s = strchr(eon+1, '@')) != NULL && (s = strchr(s+1, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
	eos = strstr(s+1, ".rpm");
	if (eos != NULL) *eos = 0;
	if (eon != NULL) *eon = 0;
	XPUSHs(sv_2mortal(newSVpvf("%s:%s", pkg->info, s+1)));
	if (eon != NULL) *eon = '@';
	if (eos != NULL) *eos = '.';
      } else {
	XPUSHs(sv_2mortal(newSVpv(pkg->info, eon-pkg->info)));
      }
    }
  } else if (pkg->h) {
    char buff[1024];
    char *p = buff;
    char *name = get_name(pkg->h, RPMTAG_NAME);
    char *version = get_name(pkg->h, RPMTAG_VERSION);
    char *release = get_name(pkg->h, RPMTAG_RELEASE);
    char *arch = headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? get_name(pkg->h, RPMTAG_ARCH) : "src";
    char *filename = get_name(pkg->h, FILENAME_TAG);

    p += snprintf(buff, sizeof(buff), "%s-%s-%s.%s:", name, version, release, arch);
    if (filename) snprintf(p, sizeof(buff) - (p-buff), "%s-%s-%s.%s.rpm", name, version, release, arch);
    if (!filename || !strcmp(p, filename)) {
      *--p = 0;
    } else {
      p += snprintf(p, sizeof(buff) - (p-buff), "%s", filename);
      *(p -= 4) = 0; /* avoid .rpm */
    }
    XPUSHs(sv_2mortal(newSVpv(buff, p-buff)));
  }
#line 2331 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_id)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::id(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1818 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX) {
    XPUSHs(sv_2mortal(newSViv(pkg->flag & FLAG_ID)));
  }
#line 2358 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_set_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_id)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_id(pkg, id=-1)");
    SP -= items;
    {
	URPM__Package	pkg;
	int	id;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 2)
	    id = -1;
	else {
	    id = (int)SvIV(ST(1));
	}
#line 1827 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX) {
    XPUSHs(sv_2mortal(newSViv(pkg->flag & FLAG_ID)));
  }
  pkg->flag &= ~FLAG_ID;
  pkg->flag |= id >= 0 && id <= FLAG_ID_MAX ? id : FLAG_ID_INVALID;
#line 2394 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_requires); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_requires)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::requires(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1837 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->requires, pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2422 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_requires_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_requires_nosense)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::requires_nosense(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1846 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->requires, pkg->h, RPMTAG_REQUIRENAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2449 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::obsoletes(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1854 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2477 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes_nosense)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::obsoletes_nosense(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1863 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2504 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes_overlap)
{
    dXSARGS;
    if (items < 2 || items > 4)
	Perl_croak(aTHX_ "Usage: URPM::Package::obsoletes_overlap(pkg, s, b_nopromote=1, direction=-1)");
    {
	URPM__Package	pkg;
	char *	s = (char *)SvPV_nolen(ST(1));
	int	b_nopromote;
	int	direction;
#line 1874 "URPM.xs"
  struct cb_overlap_s os;
  char *eon = NULL;
  char eonc = '\0';
#line 2526 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 3)
	    b_nopromote = 1;
	else {
	    b_nopromote = (int)SvIV(ST(2));
	}

	if (items < 4)
	    direction = -1;
	else {
	    direction = (int)SvIV(ST(3));
	}
#line 1878 "URPM.xs"
  os.name = s;
  os.flags = 0;
  while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
  if (*s) {
    eon = s;
    while (*s) {
      if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
      else if (*s == '<') os.flags |= RPMSENSE_LESS;
      else if (*s == '>') os.flags |= RPMSENSE_GREATER;
      else if (*s == '=') os.flags |= RPMSENSE_EQUAL;
      else break;
      ++s;
    }
    os.evr = s;
  } else
    os.evr = "";
  os.direction = direction;
  os.b_nopromote = b_nopromote;
  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* return_list_str returns a negative value is the callback has returned non-zero */
  RETVAL = return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION,
			   callback_list_str_overlap, &os) < 0;
  /* restore end of name */
  if (eon) *eon = eonc;
#line 2574 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_conflicts); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conflicts)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::conflicts(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1910 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->conflicts, pkg->h, RPMTAG_CONFLICTNAME, RPMTAG_CONFLICTFLAGS, RPMTAG_CONFLICTVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2602 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_conflicts_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conflicts_nosense)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::conflicts_nosense(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1919 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->conflicts, pkg->h, RPMTAG_CONFLICTNAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2629 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::provides(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1927 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2657 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides_nosense)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::provides_nosense(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1936 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2684 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides_overlap)
{
    dXSARGS;
    if (items < 2 || items > 4)
	Perl_croak(aTHX_ "Usage: URPM::Package::provides_overlap(pkg, s, b_nopromote=1, direction=1)");
    {
	URPM__Package	pkg;
	char *	s = (char *)SvPV_nolen(ST(1));
	int	b_nopromote;
	int	direction;
#line 1947 "URPM.xs"
  struct cb_overlap_s os;
  char *eon = NULL;
  char eonc = '\0';
#line 2706 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 3)
	    b_nopromote = 1;
	else {
	    b_nopromote = (int)SvIV(ST(2));
	}

	if (items < 4)
	    direction = 1;
	else {
	    direction = (int)SvIV(ST(3));
	}
#line 1951 "URPM.xs"
  os.name = s;
  os.flags = 0;
  while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
  if (*s) {
    eon = s;
    while (*s) {
      if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
      else if (*s == '<') os.flags |= RPMSENSE_LESS;
      else if (*s == '>') os.flags |= RPMSENSE_GREATER;
      else if (*s == '=') os.flags |= RPMSENSE_EQUAL;
      else break;
      ++s;
    }
    os.evr = s;
  } else
    os.evr = "";
  os.direction = direction;
  os.b_nopromote = b_nopromote;
  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* return_list_str returns a negative value is the callback has returned non-zero */
  RETVAL = return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION,
			   callback_list_str_overlap, &os) < 0;
  /* restore end of name */
  if (eon) *eon = eonc;
#line 2754 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_buildarchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildarchs)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::buildarchs(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1983 "URPM.xs"
  PUTBACK;
  return_list_str(NULL, pkg->h, RPMTAG_BUILDARCHS, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2781 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_excludearchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_excludearchs)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::excludearchs(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1991 "URPM.xs"
  PUTBACK;
  return_list_str(NULL, pkg->h, RPMTAG_EXCLUDEARCH, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2808 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_exclusivearchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_exclusivearchs)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::exclusivearchs(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 1999 "URPM.xs"
  PUTBACK;
  return_list_str(NULL, pkg->h, RPMTAG_EXCLUSIVEARCH, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2835 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2007 "URPM.xs"
  PUTBACK;
  return_files(pkg->h, 0);
  SPAGAIN;
#line 2862 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_md5sum); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_md5sum)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_md5sum(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2015 "URPM.xs"
  PUTBACK;
  return_list_str(NULL, pkg->h, RPMTAG_FILEMD5S, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2889 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_owner); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_owner)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_owner(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2023 "URPM.xs"
  PUTBACK;
  return_list_str(NULL, pkg->h, RPMTAG_FILEUSERNAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2916 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_group); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_group)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_group(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2031 "URPM.xs"
  PUTBACK;
  return_list_str(NULL, pkg->h, RPMTAG_FILEGROUPNAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2943 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_mtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_mtime)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_mtime(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2039 "URPM.xs"
  PUTBACK;
  return_list_int_32(pkg->h, RPMTAG_FILEMTIMES);
  SPAGAIN;
#line 2970 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_size)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_size(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2047 "URPM.xs"
  PUTBACK;
  return_list_int_32(pkg->h, RPMTAG_FILESIZES);
  SPAGAIN;
#line 2997 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_uid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_uid)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_uid(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2055 "URPM.xs"
  PUTBACK;
  return_list_int_32(pkg->h, RPMTAG_FILEUIDS);
  SPAGAIN;
#line 3024 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_gid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_gid)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_gid(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2063 "URPM.xs"
  PUTBACK;
  return_list_int_32(pkg->h, RPMTAG_FILEGIDS);
  SPAGAIN;
#line 3051 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_mode); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_mode)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_mode(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2071 "URPM.xs"
  PUTBACK;
  return_list_uint_16(pkg->h, RPMTAG_FILEMODES);
  SPAGAIN;
#line 3078 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_flags)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::files_flags(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2079 "URPM.xs"
  PUTBACK;
  return_list_int_32(pkg->h, RPMTAG_FILEFLAGS);
  SPAGAIN;
#line 3105 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_conf_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conf_files)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::conf_files(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2087 "URPM.xs"
  PUTBACK;
  return_files(pkg->h, FILTER_MODE_CONF_FILES);
  SPAGAIN;
#line 3132 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_upgrade_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_upgrade_files)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::upgrade_files(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2095 "URPM.xs"
  PUTBACK;
  return_files(pkg->h, FILTER_MODE_UPGRADE_FILES);
  SPAGAIN;
#line 3159 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_time)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::changelog_time(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2103 "URPM.xs"
  PUTBACK;
  return_list_int_32(pkg->h, RPMTAG_CHANGELOGTIME);
  SPAGAIN;
#line 3186 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_name)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::changelog_name(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2111 "URPM.xs"
  PUTBACK;
  return_list_str(NULL, pkg->h, RPMTAG_CHANGELOGNAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3213 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_text); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_text)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::changelog_text(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2119 "URPM.xs"
  PUTBACK;
  return_list_str(NULL, pkg->h, RPMTAG_CHANGELOGTEXT, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3240 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_queryformat); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_queryformat)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::queryformat(pkg, fmt)");
    SP -= items;
    {
	URPM__Package	pkg;
	char *	fmt = (char *)SvPV_nolen(ST(1));
#line 2128 "URPM.xs"
  char *s;
#line 3259 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2130 "URPM.xs"
  if (pkg->h) {
      s = headerSprintf(pkg->h, fmt,
    	rpmTagTable, rpmHeaderFormats, NULL);
      if (s) {
        XPUSHs(sv_2mortal(newSVpv_utf8(s,0)));
      }
  }
#line 3275 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_get_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_get_tag)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::get_tag(pkg, tagname)");
    SP -= items;
    {
	URPM__Package	pkg;
	int	tagname = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2143 "URPM.xs"
  PUTBACK;
  return_list_tag(pkg, tagname);
  SPAGAIN;
#line 3303 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_get_tag_modifiers); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_get_tag_modifiers)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::get_tag_modifiers(pkg, tagname)");
    SP -= items;
    {
	URPM__Package	pkg;
	int	tagname = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2152 "URPM.xs"
  PUTBACK;
  return_list_tag_modifier(pkg->h, tagname);
  SPAGAIN;
#line 3331 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_pack_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_pack_header)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::pack_header(pkg)");
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2160 "URPM.xs"
  pack_header(pkg);
#line 3355 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_update_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_update_header)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::update_header(pkg, filename, ...)");
    {
	URPM__Package	pkg;
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 2167 "URPM.xs"
  int packing = 0;
  int keep_all_tags = 0;
#line 3373 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2170 "URPM.xs"
  /* compability mode with older interface of parse_hdlist */
  if (items == 3) {
    packing = SvIV(ST(2));
  } else if (items > 3) {
    int i;
    for (i = 2; i < items-1; i+=2) {
      STRLEN len;
      char *s = SvPV(ST(i), len);

      if (len == 7 && !memcmp(s, "packing", 7)) {
	packing = SvTRUE(ST(i + 1));
      } else if (len == 13 && !memcmp(s, "keep_all_tags", 13)) {
	keep_all_tags = SvTRUE(ST(i+1));
      }
    }
  }
  RETVAL = update_header(filename, pkg, !packing && keep_all_tags, RPMVSF_DEFAULT);
  if (RETVAL && packing) pack_header(pkg);
#line 3402 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_free_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_free_header)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::free_header(pkg)");
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2195 "URPM.xs"
  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) headerFree(pkg->h);
  pkg->h = NULL;
#line 3427 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_build_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_build_info)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: URPM::Package::build_info(pkg, fileno, provides_files=NULL)");
    {
	URPM__Package	pkg;
	int	fileno = (int)SvIV(ST(1));
	char *	provides_files;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 3)
	    provides_files = NULL;
	else {
	    provides_files = (char *)SvPV_nolen(ST(2));
	}
#line 2204 "URPM.xs"
  if (pkg->info) {
    char buff[65536];
    int size;

    /* info line should be the last to be written */
    if (pkg->provides && *pkg->provides) {
      size = snprintf(buff, sizeof(buff), "@provides@%s\n", pkg->provides);
      if (size < sizeof(buff)) {
	if (provides_files && *provides_files) {
	  --size;
	  size += snprintf(buff+size, sizeof(buff)-size, "@%s\n", provides_files);
	}
	write(fileno, buff, size);
      }
    }
    if (pkg->conflicts && *pkg->conflicts) {
      size = snprintf(buff, sizeof(buff), "@conflicts@%s\n", pkg->conflicts);
      if (size < sizeof(buff)) write(fileno, buff, size);
    }
    if (pkg->obsoletes && *pkg->obsoletes) {
      size = snprintf(buff, sizeof(buff), "@obsoletes@%s\n", pkg->obsoletes);
      if (size < sizeof(buff)) write(fileno, buff, size);
    }
    if (pkg->requires && *pkg->requires) {
      size = snprintf(buff, sizeof(buff), "@requires@%s\n", pkg->requires);
      if (size < sizeof(buff)) write(fileno, buff, size);
    }
    if (pkg->summary && *pkg->summary) {
      size = snprintf(buff, sizeof(buff), "@summary@%s\n", pkg->summary);
      if (size < sizeof(buff)) write(fileno, buff, size);
    }
    size = snprintf(buff, sizeof(buff), "@info@%s\n", pkg->info);
    write(fileno, buff, size);
  } else croak("no info available for package %s",
	  pkg->h ? get_name(pkg->h, RPMTAG_NAME) : "-");
#line 3492 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_build_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_build_header)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::build_header(pkg, fileno)");
    {
	URPM__Package	pkg;
	int	fileno = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2245 "URPM.xs"
  if (pkg->h) {
    FD_t fd;

    if ((fd = fdDup(fileno)) != NULL) {
      headerWrite(fd, pkg->h, HEADER_MAGIC_YES);
      fdClose(fd);
    } else croak("unable to get rpmio handle on fileno %d", fileno);
  } else croak("no header available for package");
#line 3523 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_flag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag(pkg, name)");
    {
	URPM__Package	pkg;
	char *	name = (char *)SvPV_nolen(ST(1));
#line 2259 "URPM.xs"
  unsigned mask;
#line 3540 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2261 "URPM.xs"
  if (!strcmp(name, "skip")) mask = FLAG_SKIP;
  else if (!strcmp(name, "disable_obsolete")) mask = FLAG_DISABLE_OBSOLETE;
  else if (!strcmp(name, "installed")) mask = FLAG_INSTALLED;
  else if (!strcmp(name, "requested")) mask = FLAG_REQUESTED;
  else if (!strcmp(name, "required")) mask = FLAG_REQUIRED;
  else if (!strcmp(name, "upgrade")) mask = FLAG_UPGRADE;
  else croak("unknown flag: %s", name);
  RETVAL = pkg->flag & mask;
#line 3559 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_flag(pkg, name, value=1)");
    {
	URPM__Package	pkg;
	char *	name = (char *)SvPV_nolen(ST(1));
	int	value;
#line 2278 "URPM.xs"
  unsigned mask;
#line 3578 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 3)
	    value = 1;
	else {
	    value = (int)SvIV(ST(2));
	}
#line 2280 "URPM.xs"
  if (!strcmp(name, "skip")) mask = FLAG_SKIP;
  else if (!strcmp(name, "disable_obsolete")) mask = FLAG_DISABLE_OBSOLETE;
  else if (!strcmp(name, "installed")) mask = FLAG_INSTALLED;
  else if (!strcmp(name, "requested")) mask = FLAG_REQUESTED;
  else if (!strcmp(name, "required")) mask = FLAG_REQUIRED;
  else if (!strcmp(name, "upgrade")) mask = FLAG_UPGRADE;
  else croak("unknown flag: %s", name);
  RETVAL = pkg->flag & mask;
  if (value) pkg->flag |= mask;
  else       pkg->flag &= ~mask;
#line 3605 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_skip); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_skip)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_skip(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2297 "URPM.xs"
  RETVAL = pkg->flag & FLAG_SKIP;
#line 3631 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_skip); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_skip)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_flag_skip(pkg, value=1)");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2306 "URPM.xs"
  RETVAL = pkg->flag & FLAG_SKIP;
  if (value) pkg->flag |= FLAG_SKIP;
  else       pkg->flag &= ~FLAG_SKIP;
#line 3666 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_base); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_base)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_base(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2316 "URPM.xs"
  RETVAL = pkg->flag & FLAG_BASE;
#line 3692 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_base); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_base)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_flag_base(pkg, value=1)");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2325 "URPM.xs"
  RETVAL = pkg->flag & FLAG_BASE;
  if (value) pkg->flag |= FLAG_BASE;
  else       pkg->flag &= ~FLAG_BASE;
#line 3727 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_disable_obsolete); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_disable_obsolete)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_disable_obsolete(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2335 "URPM.xs"
  RETVAL = pkg->flag & FLAG_DISABLE_OBSOLETE;
#line 3753 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_disable_obsolete); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_disable_obsolete)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_flag_disable_obsolete(pkg, value=1)");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2344 "URPM.xs"
  RETVAL = pkg->flag & FLAG_DISABLE_OBSOLETE;
  if (value) pkg->flag |= FLAG_DISABLE_OBSOLETE;
  else       pkg->flag &= ~FLAG_DISABLE_OBSOLETE;
#line 3788 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_installed); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_installed)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_installed(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2354 "URPM.xs"
  RETVAL = pkg->flag & FLAG_INSTALLED;
#line 3814 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_installed); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_installed)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_flag_installed(pkg, value=1)");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2363 "URPM.xs"
  RETVAL = pkg->flag & FLAG_INSTALLED;
  if (value) pkg->flag |= FLAG_INSTALLED;
  else       pkg->flag &= ~FLAG_INSTALLED;
#line 3849 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_requested); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_requested)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_requested(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2373 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUESTED;
#line 3875 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_requested); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_requested)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_flag_requested(pkg, value=1)");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2382 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUESTED;
  if (value) pkg->flag |= FLAG_REQUESTED;
  else       pkg->flag &= ~FLAG_REQUESTED;
#line 3910 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_required); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_required)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_required(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2392 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUIRED;
#line 3936 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_required); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_required)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_flag_required(pkg, value=1)");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2401 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUIRED;
  if (value) pkg->flag |= FLAG_REQUIRED;
  else       pkg->flag &= ~FLAG_REQUIRED;
#line 3971 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_upgrade); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_upgrade)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_upgrade(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2411 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE;
#line 3997 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_upgrade); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_upgrade)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_flag_upgrade(pkg, value=1)");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2420 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE;
  if (value) pkg->flag |= FLAG_UPGRADE;
  else       pkg->flag &= ~FLAG_UPGRADE;
#line 4032 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_selected); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_selected)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_selected(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2430 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE ? pkg->flag & (FLAG_BASE | FLAG_REQUIRED) : 0;
#line 4058 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_available); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_available)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::flag_available(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2438 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_INSTALLED && !(pkg->flag & FLAG_UPGRADE)) ||
           (pkg->flag & FLAG_UPGRADE ? pkg->flag & (FLAG_BASE | FLAG_REQUIRED) : 0);
#line 4085 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_rate); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_rate)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::rate(pkg)");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2447 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_RATE) >> FLAG_RATE_POS;
#line 4111 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_rate); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_rate)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_rate(pkg, rate)");
    {
	URPM__Package	pkg;
	int	rate = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2456 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_RATE) >> FLAG_RATE_POS;
  pkg->flag &= ~FLAG_RATE;
  pkg->flag |= (rate >= 0 && rate <= FLAG_RATE_MAX ? rate : FLAG_RATE_INVALID) << FLAG_RATE_POS;
#line 4140 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_rflags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_rflags)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::rflags(pkg)");
    SP -= items;
    {
	URPM__Package	pkg;
#line 2466 "URPM.xs"
  I32 gimme = GIMME_V;
#line 4158 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2468 "URPM.xs"
  if (gimme == G_ARRAY && pkg->rflags != NULL) {
    char *s = pkg->rflags;
    char *eos;
    while ((eos = strchr(s, '\t')) != NULL) {
      XPUSHs(sv_2mortal(newSVpv(s, eos-s)));
      s = eos + 1;
    }
    XPUSHs(sv_2mortal(newSVpv(s, 0)));
  }
#line 4176 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_set_rflags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_rflags)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: URPM::Package::set_rflags(pkg, ...)");
    SP -= items;
    {
	URPM__Package	pkg;
#line 2482 "URPM.xs"
  I32 gimme = GIMME_V;
  char *new_rflags;
  STRLEN total_len;
  int i;
#line 4197 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2487 "URPM.xs"
  total_len = 0;
  for (i = 1; i < items; ++i)
    total_len += SvCUR(ST(i)) + 1;

  new_rflags = malloc(total_len);
  total_len = 0;
  for (i = 1; i < items; ++i) {
    STRLEN len;
    char *s = SvPV(ST(i), len);
    memcpy(new_rflags + total_len, s, len);
    new_rflags[total_len + len] = '\t';
    total_len += len + 1;
  }
  new_rflags[total_len - 1] = 0; /* but mark end-of-string correctly */

  if (gimme == G_ARRAY && pkg->rflags != NULL) {
    char *s = pkg->rflags;
    char *eos;
    while ((eos = strchr(s, '\t')) != NULL) {
      XPUSHs(sv_2mortal(newSVpv(s, eos-s)));
      s = eos + 1;
    }
    XPUSHs(sv_2mortal(newSVpv(s, 0)));
  }

  free(pkg->rflags);
  pkg->rflags = new_rflags;
#line 4233 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__DB_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_open)
{
    dXSARGS;
    if (items < 0 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::DB::open(prefix=\"\", write_perm=0)");
    {
	char *	prefix;
	int	write_perm;
#line 2523 "URPM.xs"
  URPM__DB db;
#line 4251 "URPM.c"
	URPM__DB	RETVAL;

	if (items < 1)
	    prefix = "";
	else {
	    prefix = (char *)SvPV_nolen(ST(0));
	}

	if (items < 2)
	    write_perm = 0;
	else {
	    write_perm = (int)SvIV(ST(1));
	}
#line 2525 "URPM.xs"
  read_config_files(0);
  db = malloc(sizeof(struct s_Transaction));
  db->count = 1;
  db->ts = rpmtsCreate();
  rpmtsSetRootDir(db->ts, prefix);
  if (rpmtsOpenDB(db->ts, write_perm ? O_RDWR | O_CREAT : O_RDONLY) == 0) {
    RETVAL = db;
  } else {
    RETVAL = NULL;
    rpmtsFree(db->ts);
    free(db);
  }
#line 4278 "URPM.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "URPM::DB", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_rebuild); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_rebuild)
{
    dXSARGS;
    if (items < 0 || items > 1)
	Perl_croak(aTHX_ "Usage: URPM::DB::rebuild(prefix=\"\")");
    {
	char *	prefix;
#line 2544 "URPM.xs"
  rpmts ts;
#line 4296 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    prefix = "";
	else {
	    prefix = (char *)SvPV_nolen(ST(0));
	}
#line 2546 "URPM.xs"
  read_config_files(0);
  ts = rpmtsCreate();
  rpmtsSetRootDir(ts, prefix);
  RETVAL = rpmtsRebuildDB(ts) == 0;
  rpmtsFree(ts);
#line 4311 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::DB::DESTROY(db)");
    {
	URPM__DB	db;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not a reference");
#line 2558 "URPM.xs"
  rpmtsFree(db->ts);
  if (!--db->count) free(db);
#line 4336 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__DB_traverse); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_traverse)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::DB::traverse(db, callback)");
    {
	URPM__DB	db;
	SV *	callback = ST(1);
#line 2566 "URPM.xs"
  Header header;
  rpmdbMatchIterator mi;
  int count = 0;
#line 4355 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type URPM::DB");
#line 2570 "URPM.xs"
  db->ts = rpmtsLink(db->ts, "URPM::DB::traverse");
  ts_nosignature(db->ts);
  mi = rpmtsInitIterator(db->ts, RPMDBI_PACKAGES, NULL, 0);
  while ((header = rpmdbNextIterator(mi))) {
    if (SvROK(callback)) {
      dSP;
      URPM__Package pkg = calloc(1, sizeof(struct s_Package));

      pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
      pkg->h = header;

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
      PUTBACK;

      call_sv(callback, G_DISCARD | G_SCALAR);

      SPAGAIN;
      pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
    }
    ++count;
  }
  rpmdbFreeIterator(mi);
  rpmtsFree(db->ts);
  RETVAL = count;
#line 4391 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_traverse_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_traverse_tag)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: URPM::DB::traverse_tag(db, tag, names, callback)");
    {
	URPM__DB	db;
	char *	tag = (char *)SvPV_nolen(ST(1));
	SV *	names = ST(2);
	SV *	callback = ST(3);
#line 2605 "URPM.xs"
  Header header;
  rpmdbMatchIterator mi;
  int count = 0;
#line 4413 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type URPM::DB");
#line 2609 "URPM.xs"
  if (SvROK(names) && SvTYPE(SvRV(names)) == SVt_PVAV) {
    AV* names_av = (AV*)SvRV(names);
    int len = av_len(names_av);
    int i, rpmtag;

    if (!strcmp(tag, "name"))
      rpmtag = RPMTAG_NAME;
    else if (!strcmp(tag, "whatprovides"))
      rpmtag = RPMTAG_PROVIDENAME;
    else if (!strcmp(tag, "whatrequires"))
      rpmtag = RPMTAG_REQUIRENAME;
    else if (!strcmp(tag, "whatconflicts"))
      rpmtag = RPMTAG_CONFLICTNAME;
    else if (!strcmp(tag, "group"))
      rpmtag = RPMTAG_GROUP;
    else if (!strcmp(tag, "triggeredby"))
      rpmtag = RPMTAG_TRIGGERNAME;
    else if (!strcmp(tag, "path"))
      rpmtag = RPMTAG_BASENAMES;
    else croak("unknown tag [%s]", tag);

    for (i = 0; i <= len; ++i) {
      STRLEN str_len;
      SV **isv = av_fetch(names_av, i, 0);
      char *name = SvPV(*isv, str_len);
      db->ts = rpmtsLink(db->ts, "URPM::DB::traverse_tag");
      ts_nosignature(db->ts);
      mi = rpmtsInitIterator(db->ts, rpmtag, name, str_len);
      while ((header = rpmdbNextIterator(mi))) {
	if (SvROK(callback)) {
	  dSP;
	  URPM__Package pkg = calloc(1, sizeof(struct s_Package));

	  pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
	  pkg->h = header;

	  PUSHMARK(SP);
	  XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
	  PUTBACK;

	  call_sv(callback, G_DISCARD | G_SCALAR);

	  SPAGAIN;
	  pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
	}
	++count;
      }
      rpmdbFreeIterator(mi);
      rpmtsFree(db->ts);
    } 
  } else croak("bad arguments list");
  RETVAL = count;
#line 4476 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_create_transaction); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_create_transaction)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: URPM::DB::create_transaction(db, prefix=\"/\")");
    {
	URPM__DB	db;
	char *	prefix;
	URPM__Transaction	RETVAL;

	if (sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type URPM::DB");

	if (items < 2)
	    prefix = "/";
	else {
	    prefix = (char *)SvPV_nolen(ST(1));
	}
#line 2669 "URPM.xs"
  /* this is *REALLY* dangerous to create a new transaction while another is open,
     so use the db transaction instead. */
  db->ts = rpmtsLink(db->ts, "URPM::DB::create_transaction");
  ++db->count;
  RETVAL = db;
#line 4512 "URPM.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "URPM::Transaction", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Transaction::DESTROY(trans)");
    {
	URPM__Transaction	trans;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "trans is not a reference");
#line 2684 "URPM.xs"
  rpmtsFree(trans->ts);
  if (!--trans->count) free(trans);
#line 4538 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Transaction_set_script_fd); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_set_script_fd)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Transaction::set_script_fd(trans, fdno)");
    {
	URPM__Transaction	trans;
	int	fdno = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "trans is not of type URPM::Transaction");
#line 2692 "URPM.xs"
  rpmtsSetScriptFd(trans->ts, fdDup(fdno));
#line 4562 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Transaction_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_add)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: URPM::Transaction::add(trans, pkg, ...)");
    {
	URPM__Transaction	trans;
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "trans is not of type URPM::Transaction");

	if (sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "pkg is not of type URPM::Package");
#line 2699 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX && pkg->h != NULL) {
    int update = 0;
#ifdef RPM_446
    rpmRelocation  relocations = NULL;
#else
    rpmRelocation *relocations = NULL;
#endif
    /* compability mode with older interface of add */
    if (items == 3) {
      update = SvIV(ST(2));
    } else if (items > 3) {
      int i;
      for (i = 2; i < items-1; i+=2) {
	STRLEN len;
	char *s = SvPV(ST(i), len);

	if (len == 6 && !memcmp(s, "update", 6)) {
	  update = SvIV(ST(i+1));
	} else if (len == 11 && !memcmp(s, "excludepath", 11)) {
	  if (SvROK(ST(i+1)) && SvTYPE(SvRV(ST(i+1))) == SVt_PVAV) {
	    AV *excludepath = (AV*)SvRV(ST(i+1));
	    I32 j = 1 + av_len(excludepath);
#ifdef RPM_446
	    relocations = calloc(j + 1, sizeof(*relocations));
#else
	    relocations = calloc(j + 1, sizeof(rpmRelocation));
#endif
	    while (--j >= 0) {
	      SV **e = av_fetch(excludepath, j, 0);
	      if (e != NULL && *e != NULL) {
                relocations[j].oldPath = SvPV_nolen(*e);
	      }
	    }
	  }
	}
      }
    }
    RETVAL = rpmtsAddInstallElement(trans->ts, pkg->h, (fnpyKey)(1+(pkg->flag & FLAG_ID)), update, relocations) == 0;
    /* free allocated memory, check rpm is copying it just above, at least in 4.0.4 */
    free(relocations);
  } else RETVAL = 0;
#line 4635 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_remove)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Transaction::remove(trans, name)");
    {
	URPM__Transaction	trans;
	char *	name = (char *)SvPV_nolen(ST(1));
#line 2748 "URPM.xs"
  Header h;
  rpmdbMatchIterator mi;
  int count = 0;
  char *boa = NULL, *bor = NULL;
#line 4656 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "trans is not of type URPM::Transaction");
#line 2753 "URPM.xs"
  /* hide arch in name if present */
  if ((boa = strrchr(name, '.'))) {
    *boa = 0;
    if ((bor = strrchr(name, '-'))) {
      *bor = 0;
      if (!strrchr(name, '-')) {
	*boa = '.'; boa = NULL;
      }
      *bor = '-'; bor = NULL;
    } else {
      *boa = '.'; boa = NULL;
    }
  }
  mi = rpmtsInitIterator(trans->ts, RPMDBI_LABEL, name, 0);
  while ((h = rpmdbNextIterator(mi))) {
    unsigned int recOffset = rpmdbGetIteratorOffset(mi);
    if (recOffset != 0) {
      rpmtsAddEraseElement(trans->ts, h, recOffset);
      ++count;
    }
  }
  rpmdbFreeIterator(mi);
  if (boa) *boa = '.';
  RETVAL=count;
#line 4691 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_traverse); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_traverse)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::Transaction::traverse(trans, callback)");
    {
	URPM__Transaction	trans;
	SV *	callback = ST(1);
#line 2785 "URPM.xs"
  rpmdbMatchIterator mi;
  Header h;
  int c = 0;
#line 4711 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "trans is not of type URPM::Transaction");
#line 2789 "URPM.xs"
  mi = rpmtsInitIterator(trans->ts, RPMDBI_PACKAGES, NULL, 0);
  while ((h = rpmdbNextIterator(mi))) {
    if (SvROK(callback)) {
      dSP;
      URPM__Package pkg = calloc(1, sizeof(struct s_Package));
      pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
      pkg->h = h;
      PUSHMARK(SP);
      XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
      PUTBACK;
      call_sv(callback, G_DISCARD | G_SCALAR);
      SPAGAIN;
      pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
    }
    ++c;
  }
  rpmdbFreeIterator(mi);
  RETVAL = c;
#line 4740 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_check)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: URPM::Transaction::check(trans, ...)");
    SP -= items;
    {
	URPM__Transaction	trans;
#line 2814 "URPM.xs"
  I32 gimme = GIMME_V;
  int translate_message = 0;
  int i;
#line 4760 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "trans is not of type URPM::Transaction");
#line 2818 "URPM.xs"
  for (i = 1; i < items-1; i+=2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 17 && !memcmp(s, "translate_message", 17)) {
      translate_message = SvIV(ST(i+1));
    }
  }
  if (rpmtsCheck(trans->ts)) {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(0)));
    } else if (gimme == G_ARRAY) {
      XPUSHs(sv_2mortal(newSVpv("error while checking dependencies", 0)));
    }
  } else {
    rpmps ps = rpmtsProblems(trans->ts);
    if (rpmpsNumProblems(ps) > 0) {
      if (gimme == G_SCALAR) {
	XPUSHs(sv_2mortal(newSViv(0)));
      } else if (gimme == G_ARRAY) {
	/* now translation is handled by rpmlib, but only for version 4.2 and above */
	PUTBACK;
	return_problems(ps, 1);
	SPAGAIN;
      }
    } else if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(1)));
    }
    ps = rpmpsFree(ps);
  }
#line 4799 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Transaction_order); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_order)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::Transaction::order(trans)");
    SP -= items;
    {
	URPM__Transaction	trans;
#line 2853 "URPM.xs"
  I32 gimme = GIMME_V;
#line 4817 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "trans is not of type URPM::Transaction");
#line 2855 "URPM.xs"
  if (rpmtsOrder(trans->ts) == 0) {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(1)));
    }
  } else {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(0)));
    } else if (gimme == G_ARRAY) {
      XPUSHs(sv_2mortal(newSVpv("error while ordering dependencies", 0)));
    }
  }
#line 4837 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Transaction_run); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_run)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: URPM::Transaction::run(trans, data, ...)");
    SP -= items;
    {
	URPM__Transaction	trans;
	SV *	data = ST(1);
#line 2872 "URPM.xs"
  struct s_TransactionData td = { NULL, NULL, NULL, NULL, NULL, 100000, data };
  rpmtransFlags transFlags = RPMTRANS_FLAG_NONE;
  int probFilter = 0;
  int translate_message = 0;
  int i;
#line 4860 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "trans is not of type URPM::Transaction");
#line 2878 "URPM.xs"
  for (i = 2 ; i < items - 1 ; i += 2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 4 && !memcmp(s, "test", 4)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_TEST;
    } else if (len == 11 && !memcmp(s, "excludedocs", 11)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_NODOCS;
    } else if (len == 5) {
      if (!memcmp(s, "force", 5)) {
	if (SvIV(ST(i+1))) probFilter |= (RPMPROB_FILTER_REPLACEPKG |
					  RPMPROB_FILTER_REPLACEOLDFILES |
					  RPMPROB_FILTER_REPLACENEWFILES |
					  RPMPROB_FILTER_OLDPACKAGE);
      } else if (!memcmp(s, "delta", 5))
	td.min_delta = SvIV(ST(i+1));
    } else if (len == 6 && !memcmp(s, "nosize", 6)) {
      if (SvIV(ST(i+1))) probFilter |= (RPMPROB_FILTER_DISKSPACE|RPMPROB_FILTER_DISKNODES);
    } else if (len == 9 && !memcmp(s, "noscripts", 9)) {
      if (SvIV(ST(i+1))) transFlags |= (RPMTRANS_FLAG_NOSCRIPTS |
				        RPMTRANS_FLAG_NOPRE |
				        RPMTRANS_FLAG_NOPREUN |
				        RPMTRANS_FLAG_NOPOST |
				        RPMTRANS_FLAG_NOPOSTUN );
    } else if (len == 10 && !memcmp(s, "oldpackage", 10)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_OLDPACKAGE;
    } else if (len == 9 && !memcmp(s, "repackage", 9)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_REPACKAGE;
    } else if (len == 10 && !memcmp(s, "ignorearch", 10)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_IGNOREARCH;
    } else if (len == 17 && !memcmp(s, "translate_message", 17))
      translate_message = 1;
    else if (len >= 9 && !memcmp(s, "callback_", 9)) {
      if (len == 9+4 && !memcmp(s+9, "open", 4)) {
	if (SvROK(ST(i+1))) td.callback_open = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "close", 5)) {
	if (SvROK(ST(i+1))) td.callback_close = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "trans", 5)) {
	if (SvROK(ST(i+1))) td.callback_trans = ST(i+1);
      } else if (len == 9+6 && !memcmp(s+9, "uninst", 6)) {
	if (SvROK(ST(i+1))) td.callback_uninst = ST(i+1);
      } else if (len == 9+4 && !memcmp(s+9, "inst", 4)) {
	if (SvROK(ST(i+1))) td.callback_inst = ST(i+1);
      }
    }
  }
  /* check macros */
  {
    char *repa = rpmExpand("%_repackage_all_erasures", NULL);
    if (repa && *repa && *repa != '0')
      transFlags |= RPMTRANS_FLAG_REPACKAGE;
    if (repa) free(repa);
  }
  rpmtsSetFlags(trans->ts, transFlags);
  trans->ts = rpmtsLink(trans->ts, "URPM::Transaction::run");
  rpmtsSetNotifyCallback(trans->ts, rpmRunTransactions_callback, &td);
  if (rpmtsRun(trans->ts, NULL, probFilter) > 0) {
    rpmps ps = rpmtsProblems(trans->ts);
    PUTBACK;
    return_problems(ps, translate_message);
    SPAGAIN;
    ps = rpmpsFree(ps);
  }
  rpmtsEmpty(trans->ts);
  rpmtsFree(trans->ts);
#line 4934 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_bind_rpm_textdomain_codeset); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_bind_rpm_textdomain_codeset)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: URPM::bind_rpm_textdomain_codeset()");
    {
#line 2952 "URPM.xs"
  rpm_codeset_is_utf8 = 1;
  bind_textdomain_codeset("rpm", "UTF-8");
#line 4951 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_read_config_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_read_config_files)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: URPM::read_config_files()");
    {
	int	RETVAL;
	dXSTARG;
#line 2958 "URPM.xs"
  return(read_config_files(1) == 0); /* force re-read of configuration files */
#line 4968 "URPM.c"
    }
    XSRETURN(1);
}


XS(XS_URPM_list_rpm_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_list_rpm_tag)
{
    dXSARGS;
    if (items < 0 || items > 1)
	Perl_croak(aTHX_ "Usage: URPM::list_rpm_tag(urpm=Nullsv)");
    SP -= items;
    {
	SV *	urpm;
#line 2964 "URPM.xs"
       int i = 0;
       const struct headerSprintfExtension_s * ext = rpmHeaderFormats;
#line 4986 "URPM.c"

	if (items < 1)
	    urpm = Nullsv;
	else {
	    urpm = ST(0);
	}
#line 2967 "URPM.xs"
       read_config_files(0);

       for (i = 0; i < rpmTagTableSize; i++) {
	XPUSHs(sv_2mortal(newSVpv(rpmTagTable[i].name + 7, 0)));
	XPUSHs(sv_2mortal(newSViv(rpmTagTable[i].val)));
       }

       while (ext->name != NULL) {
          if (ext->type == HEADER_EXT_MORE) {
		  ext = ext->u.more;
		  continue;
	  }
	  for (i = 0; i < rpmTagTableSize; i++) {
		  if (!strcmp(rpmTagTable[i].name, ext->name))
			  break;
	  }
	  if (i >= rpmTagTableSize && ext->type == HEADER_EXT_TAG) {
	  	XPUSHs(sv_2mortal(newSVpv(ext->name + 7, 0)));
	  	XPUSHs(sv_newmortal());
	  }
  	  ext++;
       }
#line 5016 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_rpmvercmp); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmvercmp)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: URPM::rpmvercmp(one, two)");
    {
	char *	one = (char *)SvPV_nolen(ST(0));
	char *	two = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = rpmvercmp(one, two);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_ranges_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_ranges_overlap)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: URPM::ranges_overlap(a, b, b_nopromote=1)");
    {
	char *	a = (char *)SvPV_nolen(ST(0));
	char *	b = (char *)SvPV_nolen(ST(1));
	int	b_nopromote;
#line 3001 "URPM.xs"
  char *sa = a, *sb = b;
  int aflags = 0, bflags = 0;
#line 5055 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    b_nopromote = 1;
	else {
	    b_nopromote = (int)SvIV(ST(2));
	}
#line 3004 "URPM.xs"
  while (*sa && *sa != ' ' && *sa != '[' && *sa != '<' && *sa != '>' && *sa != '=' && *sa == *sb) {
    ++sa;
    ++sb;
  }
  if ((*sa && *sa != ' ' && *sa != '[' && *sa != '<' && *sa != '>' && *sa != '=') ||
      (*sb && *sb != ' ' && *sb != '[' && *sb != '<' && *sb != '>' && *sb != '=')) {
    /* the strings are sure to be different */
    RETVAL = 0;
  } else {
    while (*sa) {
      if (*sa == ' ' || *sa == '[' || *sa == '*' || *sa == ']');
      else if (*sa == '<') aflags |= RPMSENSE_LESS;
      else if (*sa == '>') aflags |= RPMSENSE_GREATER;
      else if (*sa == '=') aflags |= RPMSENSE_EQUAL;
      else break;
      ++sa;
    }
    while (*sb) {
      if (*sb == ' ' || *sb == '[' || *sb == '*' || *sb == ']');
      else if (*sb == '<') bflags |= RPMSENSE_LESS;
      else if (*sb == '>') bflags |= RPMSENSE_GREATER;
      else if (*sb == '=') bflags |= RPMSENSE_EQUAL;
      else break;
      ++sb;
    }
    RETVAL = ranges_overlap(aflags, sa, bflags, sb, b_nopromote);
  }
#line 5092 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_parse_synthesis__XS); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_synthesis__XS)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: URPM::parse_synthesis__XS(urpm, filename, ...)");
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3039 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;

    if (depslist != NULL) {
      char buff[65536];
      char *p, *eol;
      int buff_len;
      struct s_Package pkg;
      gzFile f;
      int start_id = 1 + av_len(depslist);
      SV *callback = NULL;

      if (items > 2) {
	int i;
	for (i = 2; i < items-1; i+=2) {
	  STRLEN len;
	  char *s = SvPV(ST(i), len);

	  if (len == 8 && !memcmp(s, "callback", 8)) {
	    if (SvROK(ST(i+1))) callback = ST(i+1);
	  }
	}
      }

      PUTBACK;
      if ((f = gzopen(filename, "rb")) != NULL) {
	memset(&pkg, 0, sizeof(struct s_Package));
	buff[sizeof(buff)-1] = 0;
	p = buff;
	int ok = 1;
	while ((buff_len = gzread(f, p, sizeof(buff)-1-(p-buff))) >= 0 &&
	       (buff_len += p-buff)) {
	  buff[buff_len] = 0;
	  p = buff;
	  if ((eol = strchr(p, '\n')) != NULL) {
	    do {
	      *eol++ = 0;
	      if (!parse_line(depslist, provides, &pkg, p, urpm, callback)) { ok = 0; break; }
	      p = eol;
	    } while ((eol = strchr(p, '\n')) != NULL);
	  } else {
	    /* a line larger than sizeof(buff) has been encountered, bad file problably */
	    fprintf(stderr, "invalid line <%s>\n", p);
	    ok = 0;
	    break;
	  }
	  if (gzeof(f)) {
	    if (!parse_line(depslist, provides, &pkg, p, urpm, callback)) ok = 0;
	    break;
	  } else {
	    /* move the remaining non-complete-line at beginning */
	    memmove(buff, p, buff_len-(p-buff));
	    /* point to the end of the non-complete-line */
	    p = &buff[buff_len-(p-buff)];
	  }
	}
	if (gzclose(f) != 0) ok = 0;
	SPAGAIN;
	if (ok) {
	  XPUSHs(sv_2mortal(newSViv(start_id)));
	  XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	}
      } else {
	  SV **nofatal = hv_fetch((HV*)SvRV(urpm), "nofatal", 7, 0);
	  if (!errno) errno = EINVAL; /* zlib error */
	  if (!nofatal || !SvIV(*nofatal))
	      croak(errno == ENOENT
		      ? "unable to read synthesis file %s"
		      : "unable to uncompress synthesis file %s", filename);
      }
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 5185 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_parse_hdlist__XS); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_hdlist__XS)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: URPM::parse_hdlist__XS(urpm, filename, ...)");
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3120 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;

    if (depslist != NULL) {
      pid_t pid = 0;
      int d;
      int empty_archive = 0;
      FD_t fd;

      d = open_archive(filename, &pid, &empty_archive);
      fd = fdDup(d);
      close(d);

      if (empty_archive) {
	  XPUSHs(sv_2mortal(newSViv(1 + av_len(depslist))));
	  XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
      } else if (fdFileno(fd) >= 0) {
	Header header;
	int start_id = 1 + av_len(depslist);
	int packing = 0;
	SV *callback = NULL;

	/* compability mode with older interface of parse_hdlist */
	if (items == 3) {
	  packing = SvTRUE(ST(2));
	} else if (items > 3) {
	  int i;
	  for (i = 2; i < items-1; i+=2) {
	    STRLEN len;
	    char *s = SvPV(ST(i), len);

	    if (len == 7 && !memcmp(s, "packing", 7)) {
	      packing = SvTRUE(ST(i+1));
	    } else if (len == 8 && !memcmp(s, "callback", 8)) {
	      if (SvROK(ST(i+1))) callback = ST(i+1);
	    }
	  }
	}

	PUTBACK;
	do {
	  int count = 4;
	  header=headerRead(fd, HEADER_MAGIC_YES);
	  while (header == NULL && count > 0) {
	    fd_set readfds;
	    struct timeval timeout;

	    FD_ZERO(&readfds);
	    FD_SET(fdFileno(fd), &readfds);
	    timeout.tv_sec = 1;
	    timeout.tv_usec = 0;
	    select(fdFileno(fd)+1, &readfds, NULL, NULL, &timeout);

	    header=headerRead(fd, HEADER_MAGIC_YES);
	    --count;
	  }
	  if (header != NULL) {
	    struct s_Package pkg, *_pkg;
	    SV *sv_pkg;

	    memset(&pkg, 0, sizeof(struct s_Package));
	    pkg.flag = 1 + av_len(depslist);
	    pkg.h = header;
	    sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package",
				  _pkg = memcpy(malloc(sizeof(struct s_Package)), &pkg, sizeof(struct s_Package)));
	    if (call_package_callback(urpm, sv_pkg, callback)) {
	      if (provides) {
		update_provides(_pkg, provides);
		update_provides_files(_pkg, provides);
	      }
	      if (packing) pack_header(_pkg);
	      av_push(depslist, sv_pkg);
	    }
	  }
	} while (header != NULL);

	int ok = fdClose(fd) == 0;

	if (pid) {
	  kill(pid, SIGTERM);
	  int status;
	  int rc = waitpid(pid, &status, 0);
	  ok = rc != -1 && WEXITSTATUS(status) != 1; /* in our standard case, gzip will exit with status code 2, meaning "decompression OK, trailing garbage ignored" */
	  pid = 0;
	} else if (!empty_archive) {
	  ok = av_len(depslist) >= start_id;
	}
	SPAGAIN;
	if (ok) {
	  XPUSHs(sv_2mortal(newSViv(start_id)));
	  XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	}
      } else {
	  SV **nofatal = hv_fetch((HV*)SvRV(urpm), "nofatal", 7, 0);
	  if (!nofatal || !SvIV(*nofatal))
	      croak("cannot open hdlist file %s", filename);
      }
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 5305 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_parse_rpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_rpm)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: URPM::parse_rpm(urpm, filename, ...)");
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3228 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;

    if (depslist != NULL) {
      struct s_Package pkg, *_pkg;
      SV *sv_pkg;
      int packing = 0;
      int keep_all_tags = 0;
      SV *callback = NULL;
      rpmVSFlags vsflags = RPMVSF_DEFAULT;

      /* compability mode with older interface of parse_hdlist */
      if (items == 3) {
	packing = SvTRUE(ST(2));
      } else if (items > 3) {
	int i;
	for (i = 2; i < items-1; i+=2) {
	  STRLEN len;
	  char *s = SvPV(ST(i), len);

	  if (len == 7 && !memcmp(s, "packing", 7)) {
	    packing = SvTRUE(ST(i + 1));
	  } else if (len == 13 && !memcmp(s, "keep_all_tags", 13)) {
	    keep_all_tags = SvTRUE(ST(i+1));
	  } else if (len == 8 && !memcmp(s, "callback", 8)) {
	    if (SvROK(ST(i+1))) callback = ST(i+1);
	  } else if (len == 5) {
            if (!memcmp(s, "nopgp", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOSHA1 | RPMVSF_NOSHA1HEADER);
            }
            else if (!memcmp(s, "nogpg", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOSHA1 | RPMVSF_NOSHA1HEADER);
            }
            else if (!memcmp(s, "nomd5", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOMD5 |  RPMVSF_NOMD5HEADER);
            }
            else if (!memcmp(s, "norsa", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NORSA | RPMVSF_NORSAHEADER);
            }
            else if (!memcmp(s, "nodsa", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NODSA | RPMVSF_NODSAHEADER);
            }
          } else if (len == 9) {
            if (!memcmp(s, "nodigests", 9)) {
              if (SvIV(ST(i+1))) vsflags |= _RPMVSF_NODIGESTS;
            } else
            if (!memcmp(s, "nopayload", 9)) {
              if (SvIV(ST(i+1))) vsflags |= _RPMVSF_NOPAYLOAD;
            }
          } 
	}
      }
      PUTBACK;
      memset(&pkg, 0, sizeof(struct s_Package));
      pkg.flag = 1 + av_len(depslist);
      _pkg = memcpy(malloc(sizeof(struct s_Package)), &pkg, sizeof(struct s_Package));

      if (update_header(filename, _pkg, keep_all_tags, vsflags)) {
	sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package", _pkg);
	if (call_package_callback(urpm, sv_pkg, callback)) {
	  if (provides) {
	    update_provides(_pkg, provides);
	    update_provides_files(_pkg, provides);
	  }
	  if (packing) pack_header(_pkg);
	  av_push(depslist, sv_pkg);
	}
	SPAGAIN;
	/* only one element read */
	XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
      } else free(_pkg);
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 5400 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_verify_rpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_verify_rpm)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: URPM::verify_rpm(filename, ...)");
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 3310 "URPM.xs"
  FD_t fd;
  int i, oldlogmask;
  rpmts ts = NULL;
  struct rpmQVKArguments_s qva;
#line 5420 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3315 "URPM.xs"
  /* Don't display error messages */
  oldlogmask = rpmlogSetMask(RPMLOG_UPTO(RPMLOG_PRI(4)));
  memset(&qva, 0, sizeof(struct rpmQVKArguments_s));
  qva.qva_source = RPMQV_RPM;
  qva.qva_flags = VERIFY_ALL;
  for (i = 1 ; i < items - 1 ; i += 2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);
    if (len == 9 && !strncmp(s, "nodigests", 9)) {
      if (SvIV(ST(i+1))) qva.qva_flags &= ~VERIFY_DIGEST;
    } else if (len == 12 && !strncmp(s, "nosignatures", 12)) {
      if (SvIV(ST(i+1))) qva.qva_flags &= ~VERIFY_SIGNATURE;
    }
  }
  fd = fdOpen(filename, O_RDONLY, 0);
  if (fdFileno(fd) < 0) {
    RETVAL = 0;
  } else {
    read_config_files(0);
    ts = rpmtsCreate();
    rpmtsSetRootDir(ts, "/");
    rpmtsOpenDB(ts, O_RDONLY);
    if (rpmVerifySignatures(&qva, ts, fd, filename)) {
      RETVAL = 0;
    } else {
      RETVAL = 1;
    }
    fdClose(fd);
    rpmtsFree(ts);
  }
  rpmlogSetMask(oldlogmask);

#line 5456 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_verify_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_verify_signature)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::verify_signature(filename)");
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 3354 "URPM.xs"
  rpmts ts = NULL;
  char result[1024];
  rpmRC rc;
  FD_t fd;
  Header h;
#line 5477 "URPM.c"
	char *	RETVAL;
	dXSTARG;
#line 3360 "URPM.xs"
  fd = fdOpen(filename, O_RDONLY, 0);
  if (fdFileno(fd) < 0) {
    RETVAL = "NOT OK (could not read file)";
  } else {
    read_config_files(0);
    ts = rpmtsCreate();
    rpmtsSetRootDir(ts, "/");
    rpmtsOpenDB(ts, O_RDONLY);
    rpmtsSetVSFlags(ts, RPMVSF_DEFAULT);
    rc = rpmReadPackageFile(ts, fd, filename, &h);
    fdClose(fd);
    *result = '\0';
    switch(rc) {
      case RPMRC_OK:
	if (h) {
	  char *fmtsig = headerSprintf(
	      h,
	      "%|DSAHEADER?{%{DSAHEADER:pgpsig}}:{%|RSAHEADER?{%{RSAHEADER:pgpsig}}:"
	      "{%|SIGGPG?{%{SIGGPG:pgpsig}}:{%|SIGPGP?{%{SIGPGP:pgpsig}}:{(none)}|}|}|}|",
	      rpmTagTable, rpmHeaderFormats, NULL);
	  snprintf(result, sizeof(result), "OK (%s)", fmtsig);
	  free(fmtsig);
	} else snprintf(result, sizeof(result), "NOT OK (bad rpm): %s", rpmErrorString());
	break;
      case RPMRC_NOTFOUND:
	snprintf(result, sizeof(result), "NOT OK (signature not found): %s", rpmErrorString());
	break;
      case RPMRC_FAIL:
	snprintf(result, sizeof(result), "NOT OK (fail): %s", rpmErrorString());
	break;
      case RPMRC_NOTTRUSTED:
	snprintf(result, sizeof(result), "NOT OK (key not trusted): %s", rpmErrorString());
	break;
      case RPMRC_NOKEY:
	snprintf(result, sizeof(result), "NOT OK (no key): %s", rpmErrorString());
	break;
    }
    RETVAL = result;
    if (h) headerFree(h);
    rpmtsFree(ts);
  }

#line 5523 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM_import_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_import_pubkey)
{
    dXSARGS;
    {
#line 3408 "URPM.xs"
  int i;
  URPM__DB db = NULL;
  char *root = "/";
  STRLEN block_len = 0;
  char *block = NULL;
  STRLEN filename_len = 0;
  char *filename = NULL;
  rpmts ts;
  const unsigned char *pkt = NULL;
  ssize_t pktlen = 0;
  const byte * b = NULL;
  ssize_t blen;
  int rc;
#line 5549 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3422 "URPM.xs"
  for (i = 0; i < items-1; i+=2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 2 && !memcmp(s, "db", 2)) {
      if (sv_derived_from(ST(i+1), "URPM::DB")) {
	IV tmp = SvIV((SV*)SvRV(ST(i+1)));
	db = INT2PTR(URPM__DB, tmp);
      }
    } else if (len == 4) {
      if (!memcmp(s, "root", 4))
	root = SvPV_nolen(ST(i+1));
    } else if (len == 5) {
      if (!memcmp(s, "block", 5))
	block = SvPV(ST(i+1), block_len);
    } else if (len == 8) {
      if (!memcmp(s, "filename", 8))
	filename = SvPV(ST(i+1), filename_len);
    }
  }
  RETVAL = 1;
  /* get transaction for importing keys, open rpmdb in write mode */
  if (db) {
    ts = db->ts = rpmtsLink(db->ts, "URPM::import_pubkey");
  } else {
    /* compabilty mode to use rpmdb installed on / */
    ts = rpmtsCreate();
    read_config_files(0);
    rpmtsSetRootDir(ts, root);
    rpmtsOpenDB(ts, O_RDWR | O_CREAT);
  }
  rpmtsClean(ts);
  /* from pgpReadPkts the filename should be slurped directly in memory */
  if (filename) {
    rc = rpmioSlurp(filename, &b, &blen);
  } else if (block) {
    blen = block_len;
    b = memcpy(malloc(blen+1), block, blen+1); /* XXX should use xmalloc instead */
    rc = 0;
  } else {
    rc = 0;
  }
  if (rc || b == NULL || blen <= 0) {
    /* error reading file, or no file or block */
    RETVAL = 0;
  } else {
    /* from pgpReadPkts the remaining of method */
    const char * enc = NULL;
    const char * crcenc = NULL;
    byte * dec;
    byte * crcdec;
    size_t declen;
    size_t crclen;
    u_int32_t crcpkt, crc;
    const char * armortype = NULL;
    char * t, * te;
    int pstate = 0;
    int _rc;

    rc = PGPARMOR_ERROR;	/* XXX assume failure */

    if (pgpIsPkt(b)) {
#ifdef NOTYET	/* XXX ASCII Pubkeys only, please. */
	rc = 0;	/* XXX fish out pkt type. */
#endif
	goto exit;
    }
#define	TOKEQ(_s, _tok)	(!strncmp((_s), (_tok), sizeof(_tok)-1))
    for (t = (char *)b; t && *t; t = te) {
	if ((te = strchr(t, '\n')) == NULL)
	    te = t + strlen(t);
	else
	    te++;

	switch (pstate) {
	case 0:
	    armortype = NULL;
	    if (!TOKEQ(t, "-----BEGIN PGP "))
		continue;
	    t += sizeof("-----BEGIN PGP ")-1;

	    _rc = pgpValTok(pgpArmorTbl, t, te);
	    if (_rc < 0)
		goto exit;
	    if (_rc != PGPARMOR_PUBKEY)	/* XXX ASCII Pubkeys only, please. */
		continue;
	    armortype = t;

	    t = te - (sizeof("-----\n")-1);
	    if (!TOKEQ(t, "-----\n"))
		continue;
	    *t = '\0';
	    pstate++;
	    /*@switchbreak@*/ break;
	case 1:
	    enc = NULL;
	    _rc = pgpValTok(pgpArmorKeyTbl, t, te);
	    if (_rc >= 0)
		continue;
	    if (*t != '\n') {
		pstate = 0;
		continue;
	    }
	    enc = te;		/* Start of encoded packets */
	    pstate++;
	    /*@switchbreak@*/ break;
	case 2:
	    crcenc = NULL;
	    if (*t != '=')
		continue;
	    *t++ = '\0';	/* Terminate encoded packets */
	    crcenc = t;		/* Start of encoded crc */
	    pstate++;
	    /*@switchbreak@*/ break;
	case 3:
	    pstate = 0;
	    if (!TOKEQ(t, "-----END PGP "))
		goto exit;
	    *t = '\0';		/* Terminate encoded crc */
	    t += sizeof("-----END PGP ")-1;

	    if (armortype == NULL) /* XXX can't happen */
		continue;
	    _rc = strncmp(t, armortype, strlen(armortype));
	    if (_rc)
		continue;

	    t = te - (sizeof("-----\n")-1);
	    if (!TOKEQ(t, "-----\n"))
		goto exit;

	    if (b64decode(crcenc, (void **)&crcdec, &crclen) != 0)
		continue;
	    crcpkt = pgpGrab(crcdec, crclen);
	    crcdec = _free(crcdec);
	    if (b64decode(enc, (void **)&dec, &declen) != 0)
		goto exit;
	    crc = pgpCRC(dec, declen);
	    if (crcpkt != crc)
		goto exit;
	    b = _free(b);
	    b = dec;
	    blen = declen;
	    rc = PGPARMOR_PUBKEY;	/* XXX ASCII Pubkeys only, please. */
	    goto exit;
	    /*@notreached@*/ /*@switchbreak@*/ break;
	}
    }
    rc = PGPARMOR_NONE;

    exit:
    if (rc > PGPARMOR_NONE)
	pkt = b;
    else if (b != NULL)
	b = _free(b);
    pktlen = blen;
  }
  if (rc < 0) {
    /* import read failed */
    RETVAL = 0;
  } else if (rc != PGPARMOR_PUBKEY) {
    /* not armored public key */
    RETVAL = 0;
  } else if ((rc = rpmcliImportPubkey(ts, pkt, pktlen)) != 0) {
    /* import failed */
    RETVAL = 0;
  }
  rpmtsClean(ts);
  _free(pkt);
  rpmtsFree(ts);
#line 5723 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_stream2header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_stream2header)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::stream2header(fp)");
    SP -= items;
    {
	FILE *	fp = PerlIO_findFILE(IoIFP(sv_2io(ST(0))));
#line 3599 "URPM.xs"
    FD_t fd;
    URPM__Package pkg;
#line 5742 "URPM.c"
#line 3602 "URPM.xs"
    if ((fd = fdDup(fileno(fp)))) {
	pkg = (URPM__Package)malloc(sizeof(struct s_Package));
	memset(pkg, 0, sizeof(struct s_Package));
        pkg->h = headerRead(fd, HEADER_MAGIC_YES);
        if (pkg->h) {
            SV *sv_pkg;
            EXTEND(SP, 1);
            sv_pkg = sv_newmortal();
            sv_setref_pv(sv_pkg, "URPM::Package", (void*)pkg);
            PUSHs(sv_pkg);
        }
        Fclose(fd);
    }
#line 5757 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_spec2srcheader); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_spec2srcheader)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::spec2srcheader(specfile)");
    SP -= items;
    {
	char *	specfile = (char *)SvPV_nolen(ST(0));
#line 3620 "URPM.xs"
    rpmts ts = rpmtsCreate();
    URPM__Package pkg;
    Spec spec = NULL;
#line 5777 "URPM.c"
#line 3624 "URPM.xs"
/* ensure the config is in memory with all macro */
  read_config_files(0);
/* Do not verify architecture */
#define SPEC_ANYARCH 1
/* Do not verify whether sources exist */
#define SPEC_FORCE 1
  if (!parseSpec(ts, specfile, "/", NULL, 0, NULL, NULL, SPEC_ANYARCH, SPEC_FORCE)) {
    const char *zero = "";
    SV *sv_pkg;
    spec = rpmtsSetSpec(ts, NULL);
    if (! spec->sourceHeader)
      initSourceHeader(spec);
    pkg = (URPM__Package)malloc(sizeof(struct s_Package));
    memset(pkg, 0, sizeof(struct s_Package));
    headerAddEntry(spec->sourceHeader, RPMTAG_SOURCERPM, RPM_INT32_TYPE, &zero, 1);
    pkg->h = headerLink(spec->sourceHeader);
    sv_pkg = sv_newmortal();
    sv_setref_pv(sv_pkg, "URPM::Package", (void*)pkg);
    XPUSHs(sv_pkg);
    spec = freeSpec(spec);
  } else {
    XPUSHs(&PL_sv_undef);
    /* apparently rpmlib sets errno this when given a bad spec. */
    if (errno == EBADF)
      errno = 0;
  }
  ts = rpmtsFree(ts);
#line 5806 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_expand); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_expand)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::expand(name)");
    SP -= items;
    {
	char *	name = (char *)SvPV_nolen(ST(0));
#line 3656 "URPM.xs"
    const char * value = rpmExpand(name, NULL);
    XPUSHs(sv_2mortal(newSVpv(value, 0)));
#line 5825 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_add_macro_noexpand); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_add_macro_noexpand)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::add_macro_noexpand(macro)");
    {
	char *	macro = (char *)SvPV_nolen(ST(0));
#line 3663 "URPM.xs"
    rpmDefineMacro(NULL, macro, RMIL_DEFAULT);
#line 5842 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_del_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_del_macro)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::del_macro(name)");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
#line 3669 "URPM.xs"
    delMacro(NULL, name);
#line 5858 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_loadmacrosfile); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_loadmacrosfile)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::loadmacrosfile(filename)");
    SP -= items;
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 3675 "URPM.xs"
    rpmInitMacros(NULL, filename);
#line 5875 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_resetmacros); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_resetmacros)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: URPM::resetmacros()");
   PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 3680 "URPM.xs"
    rpmFreeMacros(NULL);
#line 5893 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_setVerbosity); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_setVerbosity)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::setVerbosity(level)");
    SP -= items;
    {
	int	level = (int)SvIV(ST(0));
#line 3686 "URPM.xs"
    rpmSetVerbosity(level);
#line 5911 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_rpmErrorString); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmErrorString)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: URPM::rpmErrorString()");
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = rpmErrorString();
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM_rpmErrorWriteTo); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmErrorWriteTo)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: URPM::rpmErrorWriteTo(fd)");
    {
	int	fd = (int)SvIV(ST(0));
#line 3695 "URPM.xs"
  rpmError_callback_data = fd;
  rpmErrorSetCallback(rpmError_callback);

  /* vim:set ts=8 sts=2 sw=2: */
#line 5948 "URPM.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_URPM); /* prototype to pass -Wmissing-prototypes */
XS(boot_URPM)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("URPM::Package::DESTROY", XS_URPM__Package_DESTROY, file);
        newXS("URPM::Package::name", XS_URPM__Package_name, file);
        newXS("URPM::Package::version", XS_URPM__Package_version, file);
        newXS("URPM::Package::release", XS_URPM__Package_release, file);
        newXS("URPM::Package::arch", XS_URPM__Package_arch, file);
        newXS("URPM::Package::is_arch_compat", XS_URPM__Package_is_arch_compat, file);
        newXS("URPM::Package::summary", XS_URPM__Package_summary, file);
        newXS("URPM::Package::description", XS_URPM__Package_description, file);
        newXS("URPM::Package::sourcerpm", XS_URPM__Package_sourcerpm, file);
        newXS("URPM::Package::packager", XS_URPM__Package_packager, file);
        newXS("URPM::Package::buildhost", XS_URPM__Package_buildhost, file);
        newXS("URPM::Package::buildtime", XS_URPM__Package_buildtime, file);
        newXS("URPM::Package::installtid", XS_URPM__Package_installtid, file);
        newXS("URPM::Package::url", XS_URPM__Package_url, file);
        newXS("URPM::Package::license", XS_URPM__Package_license, file);
        newXS("URPM::Package::distribution", XS_URPM__Package_distribution, file);
        newXS("URPM::Package::vendor", XS_URPM__Package_vendor, file);
        newXS("URPM::Package::os", XS_URPM__Package_os, file);
        newXS("URPM::Package::payload_format", XS_URPM__Package_payload_format, file);
        newXS("URPM::Package::fullname", XS_URPM__Package_fullname, file);
        newXS("URPM::Package::epoch", XS_URPM__Package_epoch, file);
        newXS("URPM::Package::compare_pkg", XS_URPM__Package_compare_pkg, file);
        newXS("URPM::Package::compare", XS_URPM__Package_compare, file);
        newXS("URPM::Package::size", XS_URPM__Package_size, file);
        newXS("URPM::Package::group", XS_URPM__Package_group, file);
        newXS("URPM::Package::filename", XS_URPM__Package_filename, file);
        newXS("URPM::Package::header_filename", XS_URPM__Package_header_filename, file);
        newXS("URPM::Package::id", XS_URPM__Package_id, file);
        newXS("URPM::Package::set_id", XS_URPM__Package_set_id, file);
        newXS("URPM::Package::requires", XS_URPM__Package_requires, file);
        newXS("URPM::Package::requires_nosense", XS_URPM__Package_requires_nosense, file);
        newXS("URPM::Package::obsoletes", XS_URPM__Package_obsoletes, file);
        newXS("URPM::Package::obsoletes_nosense", XS_URPM__Package_obsoletes_nosense, file);
        newXS("URPM::Package::obsoletes_overlap", XS_URPM__Package_obsoletes_overlap, file);
        newXS("URPM::Package::conflicts", XS_URPM__Package_conflicts, file);
        newXS("URPM::Package::conflicts_nosense", XS_URPM__Package_conflicts_nosense, file);
        newXS("URPM::Package::provides", XS_URPM__Package_provides, file);
        newXS("URPM::Package::provides_nosense", XS_URPM__Package_provides_nosense, file);
        newXS("URPM::Package::provides_overlap", XS_URPM__Package_provides_overlap, file);
        newXS("URPM::Package::buildarchs", XS_URPM__Package_buildarchs, file);
        newXS("URPM::Package::excludearchs", XS_URPM__Package_excludearchs, file);
        newXS("URPM::Package::exclusivearchs", XS_URPM__Package_exclusivearchs, file);
        newXS("URPM::Package::files", XS_URPM__Package_files, file);
        newXS("URPM::Package::files_md5sum", XS_URPM__Package_files_md5sum, file);
        newXS("URPM::Package::files_owner", XS_URPM__Package_files_owner, file);
        newXS("URPM::Package::files_group", XS_URPM__Package_files_group, file);
        newXS("URPM::Package::files_mtime", XS_URPM__Package_files_mtime, file);
        newXS("URPM::Package::files_size", XS_URPM__Package_files_size, file);
        newXS("URPM::Package::files_uid", XS_URPM__Package_files_uid, file);
        newXS("URPM::Package::files_gid", XS_URPM__Package_files_gid, file);
        newXS("URPM::Package::files_mode", XS_URPM__Package_files_mode, file);
        newXS("URPM::Package::files_flags", XS_URPM__Package_files_flags, file);
        newXS("URPM::Package::conf_files", XS_URPM__Package_conf_files, file);
        newXS("URPM::Package::upgrade_files", XS_URPM__Package_upgrade_files, file);
        newXS("URPM::Package::changelog_time", XS_URPM__Package_changelog_time, file);
        newXS("URPM::Package::changelog_name", XS_URPM__Package_changelog_name, file);
        newXS("URPM::Package::changelog_text", XS_URPM__Package_changelog_text, file);
        newXS("URPM::Package::queryformat", XS_URPM__Package_queryformat, file);
        newXS("URPM::Package::get_tag", XS_URPM__Package_get_tag, file);
        newXS("URPM::Package::get_tag_modifiers", XS_URPM__Package_get_tag_modifiers, file);
        newXS("URPM::Package::pack_header", XS_URPM__Package_pack_header, file);
        newXS("URPM::Package::update_header", XS_URPM__Package_update_header, file);
        newXS("URPM::Package::free_header", XS_URPM__Package_free_header, file);
        newXS("URPM::Package::build_info", XS_URPM__Package_build_info, file);
        newXS("URPM::Package::build_header", XS_URPM__Package_build_header, file);
        newXS("URPM::Package::flag", XS_URPM__Package_flag, file);
        newXS("URPM::Package::set_flag", XS_URPM__Package_set_flag, file);
        newXS("URPM::Package::flag_skip", XS_URPM__Package_flag_skip, file);
        newXS("URPM::Package::set_flag_skip", XS_URPM__Package_set_flag_skip, file);
        newXS("URPM::Package::flag_base", XS_URPM__Package_flag_base, file);
        newXS("URPM::Package::set_flag_base", XS_URPM__Package_set_flag_base, file);
        newXS("URPM::Package::flag_disable_obsolete", XS_URPM__Package_flag_disable_obsolete, file);
        newXS("URPM::Package::set_flag_disable_obsolete", XS_URPM__Package_set_flag_disable_obsolete, file);
        newXS("URPM::Package::flag_installed", XS_URPM__Package_flag_installed, file);
        newXS("URPM::Package::set_flag_installed", XS_URPM__Package_set_flag_installed, file);
        newXS("URPM::Package::flag_requested", XS_URPM__Package_flag_requested, file);
        newXS("URPM::Package::set_flag_requested", XS_URPM__Package_set_flag_requested, file);
        newXS("URPM::Package::flag_required", XS_URPM__Package_flag_required, file);
        newXS("URPM::Package::set_flag_required", XS_URPM__Package_set_flag_required, file);
        newXS("URPM::Package::flag_upgrade", XS_URPM__Package_flag_upgrade, file);
        newXS("URPM::Package::set_flag_upgrade", XS_URPM__Package_set_flag_upgrade, file);
        newXS("URPM::Package::flag_selected", XS_URPM__Package_flag_selected, file);
        newXS("URPM::Package::flag_available", XS_URPM__Package_flag_available, file);
        newXS("URPM::Package::rate", XS_URPM__Package_rate, file);
        newXS("URPM::Package::set_rate", XS_URPM__Package_set_rate, file);
        newXS("URPM::Package::rflags", XS_URPM__Package_rflags, file);
        newXS("URPM::Package::set_rflags", XS_URPM__Package_set_rflags, file);
        newXS("URPM::DB::open", XS_URPM__DB_open, file);
        newXS("URPM::DB::rebuild", XS_URPM__DB_rebuild, file);
        newXS("URPM::DB::DESTROY", XS_URPM__DB_DESTROY, file);
        newXS("URPM::DB::traverse", XS_URPM__DB_traverse, file);
        newXS("URPM::DB::traverse_tag", XS_URPM__DB_traverse_tag, file);
        newXS("URPM::DB::create_transaction", XS_URPM__DB_create_transaction, file);
        newXS("URPM::Transaction::DESTROY", XS_URPM__Transaction_DESTROY, file);
        newXS("URPM::Transaction::set_script_fd", XS_URPM__Transaction_set_script_fd, file);
        newXS("URPM::Transaction::add", XS_URPM__Transaction_add, file);
        newXS("URPM::Transaction::remove", XS_URPM__Transaction_remove, file);
        newXS("URPM::Transaction::traverse", XS_URPM__Transaction_traverse, file);
        newXS("URPM::Transaction::check", XS_URPM__Transaction_check, file);
        newXS("URPM::Transaction::order", XS_URPM__Transaction_order, file);
        newXS("URPM::Transaction::run", XS_URPM__Transaction_run, file);
        newXS("URPM::bind_rpm_textdomain_codeset", XS_URPM_bind_rpm_textdomain_codeset, file);
        newXS("URPM::read_config_files", XS_URPM_read_config_files, file);
        newXS("URPM::list_rpm_tag", XS_URPM_list_rpm_tag, file);
        newXS("URPM::rpmvercmp", XS_URPM_rpmvercmp, file);
        newXS("URPM::ranges_overlap", XS_URPM_ranges_overlap, file);
        newXS("URPM::parse_synthesis__XS", XS_URPM_parse_synthesis__XS, file);
        newXS("URPM::parse_hdlist__XS", XS_URPM_parse_hdlist__XS, file);
        newXS("URPM::parse_rpm", XS_URPM_parse_rpm, file);
        newXS("URPM::verify_rpm", XS_URPM_verify_rpm, file);
        newXS("URPM::verify_signature", XS_URPM_verify_signature, file);
        newXS("URPM::import_pubkey", XS_URPM_import_pubkey, file);
        newXS("URPM::stream2header", XS_URPM_stream2header, file);
        newXS("URPM::spec2srcheader", XS_URPM_spec2srcheader, file);
        newXS("URPM::expand", XS_URPM_expand, file);
        newXS("URPM::add_macro_noexpand", XS_URPM_add_macro_noexpand, file);
        newXS("URPM::del_macro", XS_URPM_del_macro, file);
        newXS("URPM::loadmacrosfile", XS_URPM_loadmacrosfile, file);
        newXS("URPM::resetmacros", XS_URPM_resetmacros, file);
        newXS("URPM::setVerbosity", XS_URPM_setVerbosity, file);
        newXS("URPM::rpmErrorString", XS_URPM_rpmErrorString, file);
        newXS("URPM::rpmErrorWriteTo", XS_URPM_rpmErrorWriteTo, file);

    /* Initialisation Section */

#line 2947 "URPM.xs"
(void) read_config_files(0);

#line 6092 "URPM.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

